-- hook into various bag types

SFBItemsDisplay_Original_ContainerFrameItemButton_OnClick = nil;
SFBItemsDisplay_Original_AllInOneInventoryFrameItemButton_OnClick = nil;
SFBItemsDisplay_Original_MyInventoryFrameItemButton_OnClick = nil;
SFBItemsDisplay_Original_BankFrameItemButtonGeneric_OnClick = nil;
SFBItemsDisplay_Original_SFBItemsFrame_GetItemToolTip = nil;





function SFBItemsDisplay_AddonSupportOnLoad()
	if ( EngInventory_ItemButton_OnClick ) then
		hooksecurefunc("EngInventory_ItemButton_OnClick",SFBItemsDisplay_EngInventory_ItemButton_OnClick);
	else
		hooksecurefunc("ContainerFrameItemButton_OnClick",SFBItemsDisplay_ContainerFrameItemButton_OnClick);
	end
	
	hooksecurefunc("BankFrameItemButtonGeneric_OnClick",SFBItemsDisplay_BankFrameItemButtonGeneric_OnClick);
	
	if ( AllInOneInventoryFrameItemButton_OnClick ) then
		hooksecurefunc("AllInOneInventoryFrameItemButton_OnClick",SFBItemsDisplay_AllInOneInventoryFrameItemButton_OnClick);
	end
	
	if ( MyInventoryFrameItemButton_OnClick ) then
		MyInventoryFrameItemButton_OnClick = SFBItemsDisplay_MyInventoryFrameItemButton_OnClick;
		hooksecurefunc("MyInventoryFrameItemButton_OnClick",SFBItemsDisplay_MyInventoryFrameItemButton_OnClick);
	end
	
	if ( myProfile ) then 
		SFBITEMS_VAR_ShowAltCounts = true;
		SFBItemsDisplay_StoreAltItems(); 
	end	

	
end

function SFBItemsDisplay_EngInventory_ItemButton_OnClick(button, ignoreShift)
        local bar, position, itm, bagnum, slotnum;

        if (EngInventory_buttons[this:GetName()] ~= nil) then
                local bar,position,itm = EngInventory_GetBarPositionAndCache();
                
                SFBITEMS_VAR_BagNum = itm["bagnum"];
		SFBITEMS_VAR_DraggedItem = itm["itemname"];
		if ( IsControlKeyDown() and IsShiftKeyDown() ) then
			SFBItemsDisplay_Debug("Key is down");
			SFBItemsDisplay_Debug("SFBITEMS_VAR_DraggedItem: "..SFBITEMS_VAR_DraggedItem);
			SFBItemsDisplay_AddItem(SFBITEMS_VAR_DraggedItem,true,1);
			return;
		end
			
        end
end

function SFBItemsDisplay_AllInOneInventoryFrameItemButton_OnClick(button, ignoreShift)
	
	local bag, slot = AllInOneInventory_GetIdAsBagSlot(this:GetID());
	SFBITEMS_VAR_BagNum = bag;
	SFBITEMS_VAR_DraggedItem = GetItemInfo(GetContainerItemLink(bag, slot));
	local icon, _, _, _, _ = GetContainerItemInfo(bag, slot);
	SFBITEMS_VAR_DraggedTexture = icon;
	if ( IsControlKeyDown() and IsShiftKeyDown() ) then
		SFBItemsDisplay_Debug("Key is down");
		SFBItemsDisplay_Debug("SFBITEMS_VAR_DraggedItem: "..SFBITEMS_VAR_DraggedItem);
		SFBItemsDisplay_AddItem(SFBITEMS_VAR_DraggedItem,true,1);
		return;
	end

end

function SFBItemsDisplay_MyInventoryFrameItemButton_OnClick(button, ignoreShift)
	
	local bag, slot = MyInventory_GetIdAsBagSlot(this:GetID());
	SFBITEMS_VAR_BagNum = bag;
	SFBITEMS_VAR_DraggedItem = GetItemInfo(GetContainerItemLink(bag, slot));
	local icon, _, _, _, _ = GetContainerItemInfo(bag, slot);
	SFBITEMS_VAR_DraggedTexture = icon;
	if ( IsControlKeyDown() and IsShiftKeyDown() ) then
		SFBItemsDisplay_Debug("Key is down");
		SFBItemsDisplay_Debug("SFBITEMS_VAR_DraggedItem: "..SFBITEMS_VAR_DraggedItem);
		SFBItemsDisplay_AddItem(SFBITEMS_VAR_DraggedItem,true,1);
		return;
	end
	
end



---------------------------------------------------------
---------------------------------------------------------
------------   Alt Item Counters     --------------------
---------------------------------------------------------

function SFBItemsDisplay_GetBagMax(name, BagNum)
	local info = 24;
   	return info;
end

-- Added by Enitjus --
function SFBItemsDisplay_StoreAltItems()
--[[
Function for alt reading done by Enitjus@category5.org July/06
Todo:
Bag 0 (Default backpack) needs to be added
Bank 0 (default Bank) needs to be added
]]--

	local containerItemNum;
	local bagNum;
	local link;
	local quantity;
	local icon;	
	local lists;
	local info;
	local PlayerList = {};
	local currentRealm = GetRealmName(); 
	
	if (not SFBInventoryHawk_AltItems) then SFBInventoryHawk_AltItems = {}; end
	
	if (not myProfile) then
		UIErrorsFrame:AddMessage(SFBITEMS_TEXT_ERRORNODATABASEFORALT , 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);	
		return;
	end

	SFBInventoryHawk_AltItems = {"itemName"};
	SFBInventoryHawk_AltItems["itemName"] = {"count","icon","alt"};
	SFBInventoryHawk_AltItems["itemName"]["count"] = 3;
	SFBInventoryHawk_AltItems["itemName"]["alt"] = {};
	
	if ( not myProfile[currentRealm] ) then
		return;
	end
	
	
	for player in pairs(myProfile[currentRealm]["Character"]) do
		table.insert(PlayerList, player);
	end
	
	players = table.getn(PlayerList);
	--DEFAULT_CHAT_FRAME:AddMessage("Players " .. players);
	if ( not players ) then return; end
	for lists = 1, players do
		name = PlayerList[lists];
		if (string.lower(name) ~= string.lower(UnitName("player")) and string.lower(name) ~= "guild" ) then
		    	--DEFAULT_CHAT_FRAME:AddMessage("Doing Player " .. name .. "");
		        for BagNum = -2, 12 do
		        	--DEFAULT_CHAT_FRAME:AddMessage("Bag #"..BagNum);
		        	
			        for containerItemNum = 1, SFBITEMS_CONS_MAX_BAG_SLOTS do
			        	--DEFAULT_CHAT_FRAME:AddMessage("Attempting for Player: " .. name .. " Bag " .. BagNum .. " Slot " .. containerItemNum);
		            		local infolink,infocount,infotexture = SFBItemsDisplay_MyProfileItemData(name, BagNum, containerItemNum);
			            	--DEFAULT_CHAT_FRAME:AddMessage(infolink);
			            	
					--returns: itemLink (string) count (number) texture (string)                         
                        		if (infolink ~= nil) then
						itemName = GetItemInfo("item:"..infolink);
						
						-- DEFAULT_CHAT_FRAME:AddMessage(itemName);
						if ( itemName ) then
							if (SFBInventoryHawk_AltItems[itemName] == nil) then 
								SFBInventoryHawk_AltItems[itemName] = {"count","icon","alt"}; 
								SFBInventoryHawk_AltItems[itemName]["alt"] = {};	
							end
				            		icon = infotexture;
				            		if (infocount == nil) then infocount = 1; end
				            		count = infocount;
				        		--DEFAULT_CHAT_FRAME:AddMessage("For " .. itemName .. " With icon " .. icon .. " and count " .. count);		        
				            		if( itemName ) then
				                		if (SFBInventoryHawk_AltItems[itemName]["count"] ~= nil) then
					                    		if ( SFBInventoryHawk_AltItems[itemName]["alt"][name] == nil ) then
						                    		SFBInventoryHawk_AltItems[itemName]["alt"][name] = {"count"};
				                				SFBInventoryHawk_AltItems[itemName]["alt"][name]["count"] = count		
						                    	else
							                	SFBInventoryHawk_AltItems[itemName]["alt"][name]["count"] = SFBInventoryHawk_AltItems[itemName]["alt"][name]["count"] + count
							                end
							                
				                    			OldCount = SFBInventoryHawk_AltItems[itemName]["count"]; 
				                    			NewCount = OldCount + count;
					            			SFBInventoryHawk_AltItems[itemName]["count"] = NewCount;
					                		--DEFAULT_CHAT_FRAME:AddMessage("Updated item " .. itemName .. "");
				            			else
				                			--SFBInventoryHawk_AltItems[itemName] = itemName;
				                			SFBInventoryHawk_AltItems[itemName]["count"] = count;
				                			SFBInventoryHawk_AltItems[itemName]["icon"] = icon;
				                			SFBInventoryHawk_AltItems[itemName]["alt"][name] = {"count"};
				                			SFBInventoryHawk_AltItems[itemName]["alt"][name]["count"] = count
				                			--DEFAULT_CHAT_FRAME:AddMessage("Added item " .. itemName .. " to table");
				            			end
				            		end
				            	end
				        end
			        end
		            	
			end	        
		end
	end 
end

--End Add --

function SFBItemsDisplay_AltTooltip()
	SFBItemsDisplay_Original_SFBItemsFrame_GetItemToolTip();
	if (SFBInventoryHawk_Player["showtooltips"] == 1 ) then
		
		for tList = 1, table.getn(SFBItemsDisplay_ItemsArray), 1 do
	
			if ( SFBItemsDisplay_ItemsArray[tList]["button"] == this:GetName() ) then
				tItem = SFBItemsDisplay_ItemsArray[tList];
			end
		end
		
		
		if ( not tItem ) then
			return;
		end
		
		if ( tItem.type ~= "category" ) then
			if (SFBInventoryHawk_AltItems[tItem["name"]] ~= nil) then
				if (SFBInventoryHawk_AltItems[tItem["name"]]["count"] > 0 and tItem["alt"] ~= 1) then
					GameTooltip:AddLine("Alt's Count"..":",SFBITEMS_VAR_Colors.alt.r,SFBITEMS_VAR_Colors.alt.g,SFBITEMS_VAR_Colors.alt.b,1,1,1);
					for index, value in SFBInventoryHawk_AltItems[tItem["name"]]["alt"] do
						GameTooltip:AddDoubleLine("     "..index..":",value["count"],SFBITEMS_VAR_Colors.normal.r,SFBITEMS_VAR_Colors.normal.g,SFBITEMS_VAR_Colors.normal.b,1,1,1);
					end
				end
			end
		end
	end
end

function SFBItemsDisplay_MyProfileItemData(player, bagID, itemSlot)

	if ( myProfile and myProfile[InventoryHawkVars.RealmName] and myProfile[InventoryHawkVars.RealmName]["Character"][player] ) then
		local playerData = myProfile[InventoryHawkVars.RealmName]["Character"][player];
		if(playerData) then
			local bagData;
			
			if ( bagID == -1 and playerData.Bank ) then
				bagData = playerData.Bank["Bag"..0];
			elseif ( bagID < 6 ) then
				if ( playerData.Inventory ) then
					bagData = playerData.Inventory["Bag"..bagID];
				end
			elseif (playerData.Bank) then
				local bId = bagID - 5;
				bagData = playerData.Bank["Bag"..bId];
			end
			if(bagData and bagData.Contents) then
				
				local itemData = bagData.Contents[itemSlot];
										
				if(itemData) then
					local itemId = itemData.Item;
					
					local count = itemData.Quantity;
					local texture = itemData.Texture;
					return itemId, tonumber(count), texture;
				end
			else 
				
			end
		end
	end

end

---------------------------------------------------------
---------------------------------------------------------
------------  End Alt Item Counters  --------------------
---------------------------------------------------------

	