--[[
	Inventory Hawk (Continued) V.4.1.6
	By Quickshot14
	(Based off the discountined Inventory Hawk version 3.4.1-2.3 By Setphen Blaising)

	WoW-Server: Echo-Isle (USA/PST)
	WoW-Characters: Zandirs (Alliance), Zaarod (Horde), Herna (Alliance), Sernity (Alliance), Martan (Alliance)

		Version History: ---------------------------------
			V.3.4.1-2.3 -
				Orignal Version By Setphen Blaising.
			V.3.6.2 -
				Began fixing the code, first updating the TOC to the newer version, fixing the menus and making at least most of it workable again. A lot of stuff in tact and working already including the imporant tracking. Many fixes made.
			V.3.8.5 -
				Fixed a lot of code with the UI dropdown changes, also removed a lot of uneeded code, menu code still broken but partly working, config tabs also not working.
			V.4.0.0 -
				Fixed all bugs and errors that I could majorly fine, everything seems to be working as intended, old menu code had to be droped (thou code is still in the script its just not used atm) new menu has been added that has the important things in it thou not very fancy.
			V.4.1.0 -
				Added new In and Out of combat alphas, can be set as the user like when there in or out of combat, so for example if the in combat alpha is set to 0% but the out of combat alpha is set to 100% then whenever the user is in combat the Inventory Hawk list display will not be able to be seen and when there out of combat it will be fully visible, very handy!
				Also added some Bagspace funcationly if its enabled in a seprate lua. When some options such as low on a track item or reached goal and also if doing a crafted item it will be displayed in BagSpace's floating text. If BagSpace is not enabled then the user will still be notifed but in there chat window instead.
			V.4.1.2-
				Actived the so far unused libarys, and also 'integreted' calvin's Charchter Profiler that inventory hawk uses to display  bank and alt counts for tracked items.
			V.4.1.6-
				Added a new multipler setting in catagories. This allows the user to easily track how much goal amounts are needed for multiple items, so for example if you add a new craft track regents the mutilplier is default to 1, if you change it to 10 the amounts needed will change in the display but the orignal goal amounts will now! This allows for dynamic changeing for multiples of items without having to change the base goal ammount! Adding a new category as normal defaults the multipler to 0 (ignored) and any item not in a catagory does not use any multiplier.
		-------------------------------------------------

		Future Plans: -------------------------------------
			Of course more bug fixes and apparent as well as more feature tweaking and adding.
		---------------------------------------------------

]]


SFBITEMS_CONS_ADDONNAME = "Inventory Hawk";
SFBITEMS_CONS_MAXDISPLAY = 30;
SFBITEMS_CONS_ITEMFIELD = "items";
SFBITEMS_CONS_TEXTWIDTH = 120;
SFBITEMS_CONS_MAX_FONT_SIZE = 30;
SFBITEMS_CONS_MIN_FONT_SIZE = 8;
SFBITEMS_CONS_MAX_BANK_BAGS = 8;
SFBITEMS_CONS_MAX_BAG_SLOTS = 28;
SFBITEMS_CONS_SETSCALE = 1;
SFBITEMS_CONS_MINALPHA = 0;
SFBITEMS_CONS_MAXALPHA = 100;
SFBITEMS_CONS_MINTITLEHEIGHT = 24;
SFBITEMS_CONS_FONTINC = 1;
SFBITEMS_CONS_DEBUG = false;
SFBITEMS_CONS_REFRESH_FREQUENCY = 1;


SFBITEMS_VAR_Enabled = false;
SFBITEMS_VAR_ForceHideDisplay = false;
SFBITEMS_VAR_PlayerLoaded = false;
SFBITEMS_VAR_CanProcessCount = false;
SFBITEMS_VAR_DraggedItem = "";
SFBITEMS_VAR_GWidth = 0;
SFBITEMS_VAR_DraggedTexture = "";
SFBITEMS_VAR_HasDrag = false;
SFBITEMS_VAR_IsBank = false;
SFBITEMS_VAR_TradeSkillNum = 0;
SFBITEMS_VAR_TradeSkillId = 0; 
SFBITEMS_VAR_MouseEntered = false;
SFBITEMS_VAR_SelectedItem = 0;
SFBITEMS_VAR_SelectedCat = 0;

InventoryHawkVars = {RealmName,PlayerName};



SFBITEMS_VAR_Colors = { };
SFBITEMS_VAR_Colors.empty = { r = 1.00, g = 0.10, b = 0.10 };
SFBITEMS_VAR_Colors.minwarning = { r = 1.00, g = 0.3, b = 0.10 };
SFBITEMS_VAR_Colors.normal = { r = 1.00, g = 0.9, b = 0.00 };
SFBITEMS_VAR_Colors.highlight = { r = 0.25, g = 0.75, b = 0.25 };
SFBITEMS_VAR_Colors.convertable = { r = 0.00, g = 0.70, b = 1.00 };
SFBITEMS_VAR_Colors.category = { r = 0.00, g = 0.70, b = 1.00 };
SFBITEMS_VAR_Colors.trade = { r = 1.00, g = 0.60, b = 0.00 };
SFBITEMS_VAR_Colors.alt = { r = 0.88, g = 0.47, b = 0.76 };
SFBITEMS_VAR_Colors.last = { r = 0.88, g = 0.47, b = 0.76 };
SFBITEMS_VAR_Colors.over = { r = 1.00, g = 1.00, b = 0.76 };
SFBITEMS_VAR_MainFrame = "SFBItemsFrame";
SFBITEMS_VAR_UIParent = "UIParent";
SFBITEMS_VAR_ESNormSetPoint = 0;
SFBITEMS_VAR_ESElseSetPoint = 0;
SFBITEMS_VAR_MainYPoint = 0;
SFBITEMS_VAR_MouseOverInfo = {cat,item};

-- Bag Display

SFBITEMS_VAR_Bag = {};
SFBITEMS_VAR_BagColors = { };
SFBITEMS_VAR_BagColors.low = { r = 1.00, g = 0.9, b = 0.10 };
SFBITEMS_VAR_BagColors.medium = { r = 0.25, g = 0.75, b = 0.25 };
SFBITEMS_VAR_BagColors.high = { r = 0.00, g = 0.70, b = 1.00 };
SFBITEMS_VAR_BagColors.empty = { r = 1.00, g = 1.00, b = 1.00 };
SFBITEMS_VAR_BagColors.full = { r = 1.00, g = 0.10, b = 0.10 };


--SFBItemsDisplay_ProfessionArray = {{SFBITEMS_TEXT_NONESELECTED,SFBITEMS_TEXT_NONESELECTED}, {SFBITEMS_TEXT_ALCHEMY,SFBITEMS_TEXT_ALCHEMY}, {SFBITEMS_TEXT_BLACKSMITHING,SFBITEMS_TEXT_BLACKSMITHING},{SFBITEMS_TEXT_COOKING,SFBITEMS_TEXT_COOKING},{SFBITEMS_TEXT_ENCHANTING,SFBITEMS_TEXT_ENCHANTING},{SFBITEMS_TEXT_ENGINEERING,SFBITEMS_TEXT_ENGINEERING},{SFBITEMS_TEXT_FIRSTAID,SFBITEMS_TEXT_FIRSTAID},{SFBITEMS_TEXT_LEATHERWORKING,SFBITEMS_TEXT_LEATHERWORKING} , {SFBITEMS_TEXT_POISONS,SFBITEMS_TEXT_POISONS},{SFBITEMS_TEXT_SMELTING,SFBITEMS_TEXT_SMELTING},{SFBITEMS_TEXT_TAILORING,SFBITEMS_TEXT_TAILORING} };
SFBItemsDisplay_ProfessionArray = nil;
-- vars 

SFBITEMS_VAR_FullCount = 0;
SFBITEMS_VAR_LastCount = 64000;
SFBITEMS_VAR_EmptySlots = 0;
SFBITEMS_VAR_ShowAltCounts = false;

SFBITEMS_VAR_TitleButtons = { }; 
SFBITEMS_VAR_TitleButtons.title = "IWTitleDisplayButton";
SFBITEMS_VAR_TitleButtons.money = "IWMoneyDisplayButton";
SFBITEMS_VAR_TitleButtons.reagent = "SFBItemsReagentDisplay";

SFBITEMS_VAR_RightClickAction = {[0] =  "none", [1] =  "use item", [2] =  "use craft"};

	MatTrack_AddMenu = { };
	MatTrack_ItemMenu = { };
	MatTrack_Menu = { };

local ICBOOL = false;

-- Load
function SFBItemsDisplay_OnLoad()
	
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("BAG_UPDATE");
	this:RegisterEvent("VARIABLES_LOADED");

	-- For Combat Alphas
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");

	-- For Money Display
	this:RegisterEvent("PLAYER_MONEY");
	
	-- For bank info
	this:RegisterEvent("BANKFRAME_OPENED");
	this:RegisterEvent("BANKFRAME_CLOSED");
	this:RegisterEvent("PLAYERBANKSLOTS_CHANGED");
	this:RegisterEvent("PLAYERBANKBAGSLOTS_CHANGED");
	this:RegisterEvent("SPELLS_CHANGED");
	
	SFBItemsDisplay_SlashOnLoad()

	InventoryHawkVars.RealmName = GetRealmName();
	InventoryHawkVars.PlayerName = UnitName("player");
	
	SFBItemsDisplay_AddonSupportOnLoad()	
		
	this:SetBackdropBorderColor(1, 1, 1);
	this:SetBackdropColor(0, 0, 0, 1);
	local version = GetAddOnMetadata("InventoryHawk", "Version");
	UIErrorsFrame:AddMessage(SFBITEMS_CONS_ADDONNAME.." v"..version.." "..SFBITEMS_TEXT_LOADED, 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);	
     	
end

function SFBItemsDisplay_SlashOnLoad()
	SlashCmdList.SFBITEMSCOMMAND = SFBItemsDisplay_SlashHandler;
     	SLASH_SFBITEMSCOMMAND1 = "/inventoryhawk";
     	SLASH_SFBITEMSCOMMAND2 = "/ih"; 
     	SLASH_SFBITEMSCOMMAND3 = "/ihawk"; 
end

function SFBItemsDisplay_SlashHandler(msg)
     if (msg) then
	  msg = string.lower(msg);
	  
	  if (string.find(msg, "enable")) then
	       	SFBItemsDisplay_DoEnable(true);
	  elseif (string.find(msg, "disable") or string.find(msg, "hide")) then
	       	SFBItemsDisplay_DoDisable();
	  elseif (string.find(msg, "reset")) then
	  	SFBItemsFrame:ClearAllPoints();
	  	SFBItemsFrame:SetPoint("TOP", "UIParent", "TOP", 0,-20 );
	  	SFBItemsDisplay_DoShow();
	  	SFBItemsDisplay_Print(SFBITEMS_TEXT_RESETMSG);
	  	
	  elseif (string.find(msg, "show")) then
	  	SFBItemsDisplay_DoShow();
	  elseif (string.find(msg, "options")) then
	  	SFBItemsDisplay_MakeMenu();
	  else
	  	SFBItemsDisplay_Print("Inventory Hawk "..SFBITEMS_TEXT_COMMANDLIST..":");
	  	SFBItemsDisplay_Print("help: "..SFBITEMS_TEXT_COMMANDYOUAREHERE..".");
	  	SFBItemsDisplay_Print("reset: "..SFBITEMS_TEXT_COMMANDRESET..".");
	  	SFBItemsDisplay_Print("disable: "..SFBITEMS_TEXT_COMMANDDISABLE..".");
	  	SFBItemsDisplay_Print("enable: "..SFBITEMS_TEXT_COMMANDENABLE..".");
	  	SFBItemsDisplay_Print("show: "..SFBITEMS_TEXT_COMMANDSHOW..".");
	  	SFBItemsDisplay_Print("hide: "..SFBITEMS_TEXT_COMMANDHIDE..".");
	  	SFBItemsDisplay_Print("options: "..SFBITEMS_TEXT_COMMANDOPTIONS..".");
	  	
	  end
     else
	  
     end
end

function SFBItemsDisplay_OnEvent()

	if ( event == "VARIABLES_LOADED" ) then
		SFBITEMS_VAR_CanProcessCount = false;
		
		if ( SFBInventoryHawk_Player == nil ) then
			SFBItemsDisplay_DoEnable(true) ;
		elseif ( SFBInventoryHawk_Player.enable == 1 ) then
			SFBItemsDisplay_DoEnable(true) ;
		end 
  		
		
		return;
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		SFBITEMS_VAR_CanProcessCount = false;
		SFBITEMS_VAR_PlayerLoaded = true;
		if ( SFBITEMS_VAR_Enabled == true ) then
			IWMoneyDisplay_UpdateMoneyDisplay();
		end 
		return;
	end
	
	if ( not SFBITEMS_VAR_Enabled) then
		return;
	end
	
	if (event == "BANKFRAME_OPENED" or event == "BANKFRAME_CLOSED" or event == "PLAYERBANKSLOTS_CHANGED" or event == "PLAYERBANKBAGSLOTS_CHANGED" ) then
		if ( not myProfile ) then
			SFBItemsDisplay_StoreBankItems();
		end
		SFBItemsDisplay_CountBankBagItems();
		SFBItemsDisplay_ChooseFrame();
		--SFBItemsDisplay_CountItems();
	elseif ( event == "BAG_UPDATE") then
		SFBItemsDisplay_CountBagItems();
		SFBItemsDisplay_ChooseFrame();
		--SFBItemsDisplay_CountItems();
	elseif ( event == "PLAYER_MONEY" ) then
		IWMoneyDisplay_UpdateMoneyDisplay();
	elseif ( event == "SPELLS_CHANGED" ) then
		SFBItemsDisplay_CreateCraftList(true);
	elseif ( event == "PLAYER_REGEN_DISABLED" ) then
		SFBItemsFrame:SetAlpha(SFBInventoryHawk_Player.MatTrack_ICAlpha);
		SFBItemsDisplayListFrame:SetAlpha(SFBInventoryHawk_Player.MatTrack_ICAlpha);
		ICBOOL = true;
	elseif ( event == "PLAYER_REGEN_ENABLED" ) then
		SFBItemsFrame:SetAlpha(SFBInventoryHawk_Player.MatTrack_OCAlpha);
		SFBItemsDisplayListFrame:SetAlpha(SFBInventoryHawk_Player.MatTrack_OCAlpha);
		ICBOOL = false;
	end
	
	
end

function SFBItemsDisplay_CheckStandalone()
	if ( SFBITEMS_VAR_Enabled == false ) then
		return;
	end

	SFBInventoryHawkButton:ClearAllPoints()
	SFBInventoryHawkButton:SetPoint("TOP",SFBITEMS_VAR_MainFrame,"TOP",0,SFBITEMS_VAR_MainYPoint);
	SFBItemsDisplay_ChooseAutoHide();

end

function SFBItemsDisplay_DoShow(chat)
	SFBInventoryHawk_Player.autohide = 0;
	SFBInventoryHawk_Player.hidelistonclick = 0;
	SFBInventoryHawk_Player.hidelist = 0;
	SFBInventoryHawk_Player.autohidetitlebutton = 0;
	SFBInventoryHawk_Player.permhidetitlebutton = 0;
	SFBItemsFrame:Show();
	SFBItemsDisplayListFrame:Show();
        SFBItemsDisplay_DoEnable(chat);
	SFBItemsDisplay_DropDown_ExitMenu();
end

function SFBItemsDisplay_DoDisable() 
	SFBITEMS_VAR_Enabled = false;
        SFBInventoryHawk_Player.enable = 0;
	
	SFBItemsFrame:Hide();
	SFBItemsDisplayListFrame:Hide();
	SFBITEMS_VAR_Bag[0].text:Hide();
	SFBITEMS_VAR_Bag[1].text:Hide();
	SFBITEMS_VAR_Bag[2].text:Hide();
	SFBITEMS_VAR_Bag[3].text:Hide();
	SFBITEMS_VAR_Bag[4].text:Hide();
	SFBITEMS_VAR_Bag[0].bar:Hide();
	SFBITEMS_VAR_Bag[1].bar:Hide();
	SFBITEMS_VAR_Bag[2].bar:Hide();
	SFBITEMS_VAR_Bag[3].bar:Hide();
	SFBITEMS_VAR_Bag[4].bar:Hide();
	SFBItemsDisplay_DropDown_ExitMenu();
	SFBItemsDisplay_Print("Inventory Hawk "..SFBITEMS_TEXT_DISABLED..".");
end

function SFBItemsDisplay_DoHide() 
	SFBItemsFrame:Hide();
	SFBItemsDisplayListFrame:Hide();
	SFBItemsDisplay_DropDown_ExitMenu();
	SFBItemsDisplay_Print("Inventory Hawk "..SFBITEMS_TEXT_HIDDEN..".");
end

function SFBItemsDisplay_DoEnable(chat) 
		
	SFBItemsDisplay_InitVars();
	SFBInventoryHawk_Player.enable = 1;
        SFBItemsFrame:Show();
        SFBItemsDisplayListFrame:Show();
	SFBItemsDisplay_LoadVars(chat);
	
	SFBITEMS_VAR_Enabled = true;
	if ( chat ) then
		SFBItemsDisplay_Print("Inventory Hawk "..SFBITEMS_TEXT_ENABLED..".");
	end
	SFBItemsDisplay_CheckStandalone();
	if ( SFBITEMS_VAR_PlayerLoaded ) then
		IWMoneyDisplay_UpdateMoneyDisplay();
		SFBITEMS_VAR_CanProcessCount = true;
		SFBItemsDisplay_CountItems();
	end
	SFBItemsDisplay_DropDown_ExitMenu();
	
end

function SFBItemsDisplay_InitVars()

	if ( type(SFBInventoryHawk_Player) ~= "table" ) then
		SFBInventoryHawk_Player = {};
	end
	
	SFBITEMS_VAR_Bag[0] = {};
	SFBITEMS_VAR_Bag[1] = {};
	SFBITEMS_VAR_Bag[2] = {};
	SFBITEMS_VAR_Bag[3] = {};
	SFBITEMS_VAR_Bag[4] = {};
		
	SFBItemsDisplay_InitPlayerVars();
	
	if ( not SFBInventoryHawk_Player.categories or type(SFBInventoryHawk_Player.categories) ~= "table") then
		SFBInventoryHawk_Player.categories = {};
		SFBInventoryHawk_Player.categories[1]={};
		SFBInventoryHawk_Player.categories[1].name = "none";
		SFBInventoryHawk_Player.categories[1].alias = "None";
		SFBInventoryHawk_Player.categories[1].items= {};
		SFBInventoryHawk_Player.categories[1].times = 0;
	elseif ( type(SFBInventoryHawk_Player.categories[1]) ~= "table" ) then
		SFBInventoryHawk_Player.categories[1]={};
		SFBInventoryHawk_Player.categories[1].name = "none";
		SFBInventoryHawk_Player.categories[1].alias = "None";
		SFBInventoryHawk_Player.categories[1].items= {};
		SFBInventoryHawk_Player.categories[1].times = 0;
	end
	
	if (type(SFBInventoryHawk_Player.defaultitemsettings) ~= "table" ) then
		SFBInventoryHawk_Player.defaultitemsettings = {};
	end

	InventoryHawkOptions_TitleOptionsBorderFrame_ICSlider:SetValue(SFBInventoryHawk_Player.MatTrack_ICAlpha * 100);		InventoryHawkOptions_TitleOptionsBorderFrame_OCSlider:SetValue(SFBInventoryHawk_Player.MatTrack_OCAlpha * 100);
end

function SFBItemsDisplay_InitPlayerVars()
	SFBItemsDisplay_SetPlayerArrayVar("MatTrack_ICAlpha",1);
	SFBItemsDisplay_SetPlayerArrayVar("MatTrack_OCAlpha",1);
	SFBItemsDisplay_SetPlayerArrayVar("enable",1);
	SFBItemsDisplay_SetPlayerArrayVar("title",SFBITEMS_CONS_ADDONNAME);
	SFBItemsDisplay_SetPlayerArrayVar("titlebuttondisplay","title");
	SFBItemsDisplay_SetPlayerArrayVar("standalone",0);
	SFBItemsDisplay_SetPlayerArrayVar("alphabetizelist",0);
	SFBItemsDisplay_SetPlayerArrayVar("showtooltips",1);
	SFBItemsDisplay_SetPlayerArrayVar("permhidetitlebutton",0);
	SFBItemsDisplay_SetPlayerArrayVar("alignment","left");
	SFBItemsDisplay_SetPlayerArrayVar("listfontsize",12);
	SFBItemsDisplay_SetPlayerArrayVar("titlefontsize",14);
	SFBItemsDisplay_SetPlayerArrayVar("autohidetitlebutton",0);
	SFBItemsDisplay_SetPlayerArrayVar("hideempty",1);
	SFBItemsDisplay_SetPlayerArrayVar("listalpha",0.9);
	SFBItemsDisplay_SetPlayerArrayVar("listbackgroundalpha",0.2);
	SFBItemsDisplay_SetPlayerArrayVar("makeitemsbackground",0);
	SFBItemsDisplay_SetPlayerArrayVar("autohide",0);
	SFBItemsDisplay_SetPlayerArrayVar("hideicons",0);
	SFBItemsDisplay_SetPlayerArrayVar("hidelistonclick",0);
	SFBItemsDisplay_SetPlayerArrayVar("hidelist",0);
	SFBItemsDisplay_SetPlayerArrayVar("titlebuttonalpha",1);
	SFBItemsDisplay_SetPlayerArrayVar("enable",1);
	SFBItemsDisplay_SetPlayerArrayVar("reverselist",0);
	SFBItemsDisplay_SetPlayerArrayVar("showbankcount",0);
	SFBItemsDisplay_SetPlayerArrayVar("displayemptyslots",1);
	SFBItemsDisplay_SetPlayerArrayVar("bags_showbagtext",1);
	SFBItemsDisplay_SetPlayerArrayVar("bags_showbagbars",0);
	SFBItemsDisplay_SetPlayerArrayVar("bags_showbagbartext",0);
	SFBItemsDisplay_SetPlayerArrayVar("bags_reversebagbars",0);
	SFBItemsDisplay_SetPlayerArrayVar("peritemautohide",1);
	SFBItemsDisplay_SetPlayerArrayVar("showitemoptions",1);
	local version = GetAddOnMetadata("InventoryHawk", "Version");
	SFBItemsDisplay_SetPlayerArrayVar("version",version);
end

function SFBItemsDisplay_CreateCraftList(force)
	if not SFBItemsDisplay_ProfessionArray or force then
		SFBItemsDisplay_ProfessionArray = {{SFBITEMS_TEXT_NONESELECTED,SFBITEMS_TEXT_NONESELECTED}};
		
		local i = 1;
		while true do
			local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL);
			
			if not spellName then
				do break end
			end
			
			if strlen(spellRank) > 1 and string.find(spellRank,"%s") == nil and not IsPassiveSpell(spellName) and not IsHarmfulSpell(spellName) and not IsHelpfulSpell(spellName) then
				table.insert(SFBItemsDisplay_ProfessionArray,{spellName,spellName});
			end
			
			i = i + 1;
		end
	end 
end

function SFBItemsDisplay_InitCatVars(item)

	local tNum = 0;

	for cat = 1, table.getn(SFBItemsDisplay_CategoriesArray), 1 do
		if ( SFBItemsDisplay_CategoriesArray[cat].name == item.name ) then
			tNum = cat;
			break;
		end
	end
	
	if ( tNum == 0 ) then
		return;
	end
	
	SFBItemsDisplay_SetCatArrayVar(tNum,"name","New")
	SFBItemsDisplay_SetCatArrayVar(tNum,"alias","New")
	SFBItemsDisplay_SetCatArrayVar(tNum,"forceshow",0)
	SFBItemsDisplay_SetCatArrayVar(tNum,"hide",0)
	SFBItemsDisplay_SetCatArrayVar(tNum,"open",1)
	SFBItemsDisplay_SetCatArrayVar(tNum,"button","")
	SFBItemsDisplay_SetCatArrayVar(tNum,"hideemptycategory",0)
	SFBItemsDisplay_SetCatArrayVar(tNum,"type","category");
	SFBItemsDisplay_SetCatArrayVar(tNum,"rightclicktrade","");
	SFBItemsDisplay_SetCatArrayVar(tNum,"rightclickprofession","");
	SFBItemsDisplay_SetCatArrayVar(tNum,"rightclickprofessionid",0);
	SFBItemsDisplay_SetCatArrayVar(tNum,"rightclicktradeicon","");
	SFBItemsDisplay_SetCatArrayVar(tNum,"rightclickprofessionicon","");
	
	if (type(SFBItemsDisplay_CategoriesArray[tNum].items) ~= "table" ) then
		SFBItemsDisplay_CategoriesArray[tNum].items = {};
	end

end

function SFBItemsDisplay_InitListItem(item)
	
	if ( not item ) then return; end
	local tCat, tNum;
	if ( type(item) == "table" ) then
		tCat, tNum = SFBItemsDisplay_GetItem(item.name);
	else
		tCat, tNum = SFBItemsDisplay_GetItem(item);
	end
	
	if ( not tCat ) then
		return;
	end
	
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"name","New Item");
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"alias",item.name);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"convamount",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"highlightnum",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"alarm",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"minalarm",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"type","reagent");
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"icon","");
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"bankcount",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"goalincludebank",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"hideongoalreached",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"convincludebank",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"warnincludebank",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"hide",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"hidewhenempty",1);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"showifbank",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"autohide",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"rightclicktrade","");
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"rightclickprofession","");
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"rightclickprofessionid",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"rightclicktradeicon","");
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"rightclickprofessionicon","");
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"alterlowwarning",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"alertgoal",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"rightclickuseitem",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"itembag",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"itemslot",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"count",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"goalcount",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"wasinit",1);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"hideemptycategory",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"hideongoalreached",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"rightclickaction",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"rightcontrolclickaction",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"hidetilgoal",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"hidetilconv",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"alt",0);
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"category","none");
	SFBItemsDisplay_SetCatItemArrayVar(tCat,tNum,"resetgoal",0);
	
end


function SFBItemsDisplay_InitCatItemVars()
	for cat = 1, table.getn(SFBItemsDisplay_CategoriesArray), 1 do
		for icnt = 1, table.getn(SFBItemsDisplay_CategoriesArray[cat].items), 1 do
			SFBItemsDisplay_CategoriesArray[cat].items[icnt].button = "";
			SFBItemsDisplay_CategoriesArray[cat].items[icnt].count = 0;
			
			SFBItemsDisplay_InitListItem( SFBItemsDisplay_CategoriesArray[cat].items[icnt]);
			SFBItemsDisplay_CategoriesArray[cat].items[icnt].wasinit = 1;
		end
	end
end

function SFBItemsDisplay_LoadVars(chat)

	SFBItemsDisplay_CategoriesArray = SFBInventoryHawk_Player.categories;
	
	for cat, value in pairs(SFBItemsDisplay_CategoriesArray) do
		SFBItemsDisplay_InitCatVars(value);
	end
	
	
	SFBItemsDisplay_InitCatItemVars();
	
		
	-- load

	SFBItemsDisplay_SetTitle(SFBInventoryHawk_Player.title) ;
	
	SFBITEMS_VAR_Bag[0].text = getglobal("IWMoneyDisplayMainBagText");
	SFBITEMS_VAR_Bag[1].text = getglobal("IWMoneyDisplayBagText0");
	SFBITEMS_VAR_Bag[2].text = getglobal("IWMoneyDisplayBagText1");
	SFBITEMS_VAR_Bag[3].text = getglobal("IWMoneyDisplayBagText2");
	SFBITEMS_VAR_Bag[4].text = getglobal("IWMoneyDisplayBagText3");
	
	SFBITEMS_VAR_Bag[0].bar = getglobal("IWMoneyDisplayMainBagStatusBar");
	SFBITEMS_VAR_Bag[1].bar = getglobal("IWMoneyDisplayBag0StatusBar");
	SFBITEMS_VAR_Bag[2].bar = getglobal("IWMoneyDisplayBag1StatusBar");
	SFBITEMS_VAR_Bag[3].bar = getglobal("IWMoneyDisplayBag2StatusBar");
	SFBITEMS_VAR_Bag[4].bar = getglobal("IWMoneyDisplayBag3StatusBar");
	
	SFBITEMS_VAR_Bag[0].text:Show();
	SFBITEMS_VAR_Bag[1].text:Show();
	SFBITEMS_VAR_Bag[2].text:Show();
	SFBITEMS_VAR_Bag[3].text:Show();
	SFBITEMS_VAR_Bag[4].text:Show();
	
	SFBITEMS_VAR_Bag[0].bar:Show();
	SFBITEMS_VAR_Bag[1].bar:Show();
	SFBITEMS_VAR_Bag[2].bar:Show();
	SFBITEMS_VAR_Bag[3].bar:Show();
	SFBITEMS_VAR_Bag[4].bar:Show();
	
	-- Detect the Insomniax BibActionBar
	if (BIB_ACTION_BAR_COUNT) then
		if ( MainMenuBarBackpackButton ) then
			SFBITEMS_VAR_Bag[0].text:SetPoint("BOTTOMRIGHT", "MainMenuBarBackpackButton", "BOTTOMRIGHT",0, 0);
			SFBITEMS_VAR_Bag[1].text:SetPoint("BOTTOMRIGHT", "CharacterBag0Slot", "BOTTOMRIGHT",0, 0);
			SFBITEMS_VAR_Bag[2].text:SetPoint("BOTTOMRIGHT", "CharacterBag1Slot", "BOTTOMRIGHT",0, 0);
			SFBITEMS_VAR_Bag[3].text:SetPoint("BOTTOMRIGHT", "CharacterBag2Slot", "BOTTOMRIGHT",0, 0);
			SFBITEMS_VAR_Bag[4].text:SetPoint("BOTTOMRIGHT", "CharacterBag3Slot", "BOTTOMRIGHT",0, 0);
		elseif (BibMainMenuBarBackpackButton) then
			SFBITEMS_VAR_Bag[0].text:SetPoint("BOTTOMRIGHT", "BibMainMenuBarBackpackButton", "BOTTOMRIGHT",0, 0);
			SFBITEMS_VAR_Bag[1].text:SetPoint("BOTTOMRIGHT", "BibCharacBag0Slot", "BOTTOMRIGHT",0, 0);
			SFBITEMS_VAR_Bag[2].text:SetPoint("BOTTOMRIGHT", "BibCharacBag1Slot", "BOTTOMRIGHT",0, 0);
			SFBITEMS_VAR_Bag[3].text:SetPoint("BOTTOMRIGHT", "BibCharacBag2Slot", "BOTTOMRIGHT",0, 0);
			SFBITEMS_VAR_Bag[4].text:SetPoint("BOTTOMRIGHT", "BibCharacBag3Slot", "BOTTOMRIGHT",0, 0);
		end 
	end
	
	if (type(SFBInventoryHawk_Player[SFBITEMS_CONS_ITEMFIELD]) == "table" ) then
		SFBItemsDisplay_ItemsArray = SFBInventoryHawk_Player[SFBITEMS_CONS_ITEMFIELD];
		SFBItemsDisplay_Print("Converting Old Items List");
		SFBItemsDisplay_ConvertOldItems();
	end
	
	if ( chat ) then
		local version = GetAddOnMetadata("InventoryHawk", "Version");
		SFBItemsDisplay_Print(SFBITEMS_CONS_ADDONNAME.." v"..version.." "..SFBITEMS_TEXT_LOADED);
	end
	
end




function SFBItemsDisplay_SetPlayerArrayVar(ftableitem,defaultvalue)

	if ( not defaultvalue ) then
		defaultvalue = 0;
	end
	
	SFBInventoryHawk_Player[ftableitem] = SFBInventoryHawk_Player[ftableitem] or defaultvalue;

			
end

function SFBItemsDisplay_SetCatArrayVar(cat,ftableitem,defaultvalue)

	if ( not defaultvalue ) then
		defaultvalue = 0;
	end
	if ( SFBItemsDisplay_CategoriesArray[cat][ftableitem] == nil ) then
		SFBItemsDisplay_CategoriesArray[cat][ftableitem] = defaultvalue;
	else
		SFBItemsDisplay_CategoriesArray[cat][ftableitem] = SFBItemsDisplay_CategoriesArray[cat][ftableitem];
	end
	
			
end

function SFBItemsDisplay_SetCatItemArrayVar(cat, fitem, ftableitem,defaultvalue)
	
	if ( not defaultvalue ) then
		defaultvalue = 0;
	end
	
	if ( SFBInventoryHawk_Player.defaultitemsettings[ftableitem] == nil ) then
		SFBInventoryHawk_Player.defaultitemsettings[ftableitem] = defaultvalue;
	end
	
	if ( SFBItemsDisplay_CategoriesArray[cat].items[fitem][ftableitem] == nil ) then
		SFBItemsDisplay_CategoriesArray[cat].items[fitem][ftableitem] = SFBInventoryHawk_Player.defaultitemsettings[ftableitem];
	else
		SFBItemsDisplay_CategoriesArray[cat].items[fitem][ftableitem] = SFBItemsDisplay_CategoriesArray[cat].items[fitem][ftableitem];
	end
end

function SFBItemsDisplay_GetCategory(category, rtnDefault)
	for cat, value in pairs(SFBItemsDisplay_CategoriesArray) do
		if ( value.name == category ) then
			return cat;
		end
	end
	if ( rtnDefault ) then
		return 1;
	else
		return nil;
	end
end

function SFBItemsDisplay_GetItem(name)
	SFBItemsDisplay_Debug("Looking for Item: "..name);
	for cat, value in pairs(SFBItemsDisplay_CategoriesArray) do
		if ( not SFBItemsDisplay_CategoriesArray[cat].items ) then
			SFBItemsDisplay_CategoriesArray[cat] = nil;
		else
			for index, valueA in pairs(SFBItemsDisplay_CategoriesArray[cat].items) do
				if ( SFBItemsDisplay_CategoriesArray[cat].items[index].name ) then
					if ( SFBItemsDisplay_CategoriesArray[cat].items[index].name == name ) then
						SFBItemsDisplay_Debug("Got Item: "..name);
						return 	cat, index;
					end
				end
			end
		end
	end
	return nil, nil;
end

function SFBItemsDisplay_AddCategory(name,dontrundisplay) 
	if ( not SFBItemsDisplay_GetCategory(name) ) then
		local newItem = {};
		newItem.name = name;
		newItem.alias = name;
		newItem.items = {};
		newItem.times = 0;
		tinsert(SFBItemsDisplay_CategoriesArray,newItem);
		SFBItemsDisplay_InitCatVars(newItem);
		if ( not dontrundisplay ) then
			SFBItemsDisplay_ChooseFrame();
		end
	end
end

function SFBItemsDisplay_AddCategoryNEW(name,dontrundisplay) 
	if ( not SFBItemsDisplay_GetCategory(name) ) then
		local newItem = {};
		newItem.name = name;
		newItem.alias = name;
		newItem.items = {};
		newItem.times = 1;
		tinsert(SFBItemsDisplay_CategoriesArray,newItem);
		SFBItemsDisplay_InitCatVars(newItem);
		if ( not dontrundisplay ) then
			SFBItemsDisplay_ChooseFrame();
		end
	end
end

function SFBItemsDisplay_ConvertOldItems()

	local catIndx = SFBItemsDisplay_GetCategory("none",true);
	for nCnt = 1, table.getn(SFBItemsDisplay_ItemsArray), 1 do
		local tItem = SFBItemsDisplay_ItemsArray[nCnt];
		if ( tItem.type == "category" ) then
			SFBItemsDisplay_Debug("Add Category: "..tItem.name);
			SFBItemsDisplay_AddCategory(tItem.name,true);
			catIndx = SFBItemsDisplay_GetCategory(tItem.name,true);
		else
			SFBItemsDisplay_Debug("Add Item: "..tItem.name);
			SFBItemsDisplay_AddItem(tItem,false,catIndx,true);
		
		end
	end

	SFBInventoryHawk_Player[SFBITEMS_CONS_ITEMFIELD] = nil;
end

-- Static Popups
StaticPopupDialogs["SFBItemsDisplay_Disable"] = {
	text = SFBITEMS_TEXT_DISABLE.." "..SFBITEMS_CONS_ADDONNAME,
	button1 = TEXT(ACCEPT),
	button2 = TEXT(CANCEL),
	whileDead = 1,
	OnAccept = function()
		SFBItemsDisplay_DoDisable();
	end,
	timeout = 0
};

StaticPopupDialogs["SFBItemsDisplay_ClearList"] = {
	text = SFBITEMS_TEXT_CLEARLIST,
	button1 = TEXT(ACCEPT),
	button2 = TEXT(CANCEL),
	whileDead = 1,
	OnAccept = function()
		SFBItemsDisplay_ClearList();
	end,
	timeout = 0
};


StaticPopupDialogs["SFBItemsDisplay_AddItem"] = {
	text = SFBITEMS_TEXT_ADDITEM_POPUP,
	button1 = TEXT(ACCEPT),
	button2 = TEXT(CANCEL),
	hasEditBox = 1,
	whileDead = 1,
	maxLetters = 60,
	OnAccept = function()
		SFBITEMS_VAR_HasDrag = false;
		local value = getglobal(this:GetParent():GetName().."EditBox"):GetText();
		SFBItemsDisplay_AddItem(value,true);
		getglobal(this:GetParent():GetName().."EditBox"):SetText("");
	end,
	timeout = 0,
	EditBoxOnEnterPressed = function()
		SFBITEMS_VAR_HasDrag = false;
		local value = getglobal(this:GetParent():GetName().."EditBox"):GetText();
		SFBItemsDisplay_AddItem(value,true);
		
		getglobal(this:GetParent():GetName().."EditBox"):SetText("");
		this:GetParent():Hide();
	end
};



StaticPopupDialogs["SFBItemsDisplay_AddCategory"] = {
	text = SFBITEMS_TEXT_ADDNEWCATEGORYBAR,
	button1 = TEXT(ACCEPT),
	button2 = TEXT(CANCEL),
	hasEditBox = 1,
	whileDead = 1,
	maxLetters = 20,
	OnAccept = function()
		local value = getglobal(this:GetParent():GetName().."EditBox"):GetText();
		SFBItemsDisplay_AddCategory(value);
		getglobal(this:GetParent():GetName().."EditBox"):SetText("");
	end,
	timeout = 0,
	EditBoxOnEnterPressed = function()
		local value = getglobal(this:GetParent():GetName().."EditBox"):GetText();
		SFBItemsDisplay_AddCategory(value);
		getglobal(this:GetParent():GetName().."EditBox"):SetText("");
		this:GetParent():Hide();
	end
};




-- Inventory Hawk Config Frame 
function InventoryHawk_ConfigFrame_OnLoad()
	UIPanelWindows["InventoryHawk_ConfigFrame"] = {area = "center", pushable = 0};
end

function InventoryHawk_ConfigFrame_OnHide()
	if(MYADDONS_ACTIVE_OPTIONSFRAME == this) then
		ShowUIPanel(myAddOnsFrame);
	end
end

function SFBInventoryHawkButton_OnLoad()
	this:RegisterForClicks("LeftButtonUp","RightButtonUp");
	this:RegisterForDrag("LeftButton", "RightButton");
end

function SFBInventoryHawkButton_OnClick(button)
	
	if ( button == "LeftButton" ) then
		if ( CursorHasItem() ) then
			SFBItemsDisplay_ReceiveDrag();
		elseif ( SFBInventoryHawk_Player.hidelistonclick == 1 ) then
			SFBItemsDisplay_TogglePlayerArrayVar("hidelist",SFBItemsDisplay_ChooseAutoHide);
		else
			
		end
	elseif ( button == "RightButton" ) then
		SFBItemsDisplay_MakeMenu();
	end

end

function SFBItemsDisplay_ToggleVar(ftableitem,runfunctionafter)
	if ( not fvar ) then
		return;
	end
	
	local lvar = getglobal(fvar);
	
	if ( not lvar[ftableitem] ) then
		return;
	end
	
	if ( type( lvar[ftableitem] ) == "string" ) then 
		if ( lvar[ftableitem] == "true" ) then
			lvar[ftableitem] = "false";
		elseif ( lvar[ftableitem] == "1" ) then
			lvar[ftableitem] = "0";
		elseif ( lvar[ftableitem] == "false" ) then
			lvar[ftableitem] = "true";
		elseif ( lvar[ftableitem] == "0" ) then
			lvar[ftableitem] = "true";
		end
	elseif type( lvar[ftableitem] == "number" ) then 
		if ( lvar[ftableitem] == 1 ) then
			lvar[ftableitem] = 0;
		else
			lvar[ftableitem] = 1;
		end
	elseif type( lvar[ftableitem] == "boolean" ) then 
		if ( lvar[ftableitem] == true ) then
			lvar[ftableitem] = false;
		else
			lvar[ftableitem] = true;
		end
	end
	
	if ( runfunctionafter ) then
		runfunctionafter();
	end
end

function SFBItemsDisplay_TogglePlayerArrayVar(ftableitem,runfunctionafter)
	
	if ( not SFBInventoryHawk_Player[ftableitem] ) then
		return;
	end
	
	if ( type( SFBInventoryHawk_Player[ftableitem] ) == "string" ) then 
		if ( SFBInventoryHawk_Player[ftableitem] == "true" ) then
			SFBInventoryHawk_Player[ftableitem] = "false";
		elseif ( SFBInventoryHawk_Player[ftableitem] == "1" ) then
			SFBInventoryHawk_Player[ftableitem] = "0";
		elseif ( SFBInventoryHawk_Player[ftableitem] == "false" ) then
			SFBInventoryHawk_Player[ftableitem] = "true";
		elseif ( SFBInventoryHawk_Player[ftableitem] == "0" ) then
			SFBInventoryHawk_Player[ftableitem] = "true";
		end
	elseif type( SFBInventoryHawk_Player[ftableitem] == "number" ) then 
		if ( SFBInventoryHawk_Player[ftableitem] == 1 ) then
			SFBInventoryHawk_Player[ftableitem] = 0;
		else
			SFBInventoryHawk_Player[ftableitem] = 1;
		end
	elseif type( SFBInventoryHawk_Player[ftableitem] == "boolean" ) then 
		if ( SFBInventoryHawk_Player[ftableitem] == true ) then
			SFBInventoryHawk_Player[ftableitem] = false;
		else
			SFBInventoryHawk_Player[ftableitem] = true;
		end
	end
	
	if ( runfunctionafter ) then
		runfunctionafter();
	end
end







function SFBItemsDisplay_GetSpellID(spell)
	for id = 1, 180 do 
	        local spellName, subSpellName = GetSpellName(id, "spell");
	        if (spellName) then
	        
	            -- find the highest level healthstone we can make
	            if (string.find(spellName, spell, 1, true)) then
	            	return id;
	            end    	                
	            
	        end
    	end
end





-- Bank functions
-- Ripped completely from Merphle's BankStatement

function SFBItemsDisplay_StoreBankItems()
	local maxContainerItems;
	local containerItemNum;
	local bagNum;
	local link;
	local quantity;
	local icon;
	
	-- Banknon compatibility brought to you by enitjus
	if (Banknon ~= nil) then
	    if (not (Banknon:IsVisible())) then return; end
	else
	    --if (not (BankFrame:IsVisible())) then return; end
	end
	
	if (not SFBInventoryHawk_BankItems) then SFBInventoryHawk_BankItems = {}; end

	SFBInventoryHawk_BankItems = {};

	maxContainerItems = GetContainerNumSlots(-1);
	if ( maxContainerItems ) then
		SFBInventoryHawk_BankItems.bank = {};
		for containerItemNum = 1, maxContainerItems do
			SFBInventoryHawk_BankItems.bank[containerItemNum] = {};
			link = GetContainerItemLink(BANK_CONTAINER, containerItemNum);
			icon, quantity = GetContainerItemInfo(BANK_CONTAINER, containerItemNum);
			if( link ) then
				SFBInventoryHawk_BankItems.bank[containerItemNum].link = link;
				SFBInventoryHawk_BankItems.bank[containerItemNum].quantity = quantity;
				SFBInventoryHawk_BankItems.bank[containerItemNum].icon = icon;
			end
		end
	end

	for bagNum = 5, 11 do
		maxContainerItems = GetContainerNumSlots(bagNum);
		
		if( maxContainerItems ) then
			SFBInventoryHawk_BankItems["bag"..bagNum] = {};
			local id = BankButtonIDToInvSlotID(bagNum, 1);
			link = GetInventoryItemLink("player", id);
			icon = GetInventoryItemTexture("player", id);
			SFBInventoryHawk_BankItems["bag"..bagNum].link = link;
			SFBInventoryHawk_BankItems["bag"..bagNum].icon = icon;
			SFBInventoryHawk_BankItems["bag"..bagNum].bagsize = maxContainerItems;
			for containerItemNum = 1, maxContainerItems do
				SFBInventoryHawk_BankItems["bag"..bagNum][containerItemNum] = {};
				link = GetContainerItemLink(bagNum, containerItemNum);
				icon, quantity = GetContainerItemInfo(bagNum, containerItemNum);
				if( link ) then
					SFBInventoryHawk_BankItems["bag"..bagNum][containerItemNum].link = link;
					SFBInventoryHawk_BankItems["bag"..bagNum][containerItemNum].quantity = quantity;
					SFBInventoryHawk_BankItems["bag"..bagNum][containerItemNum].icon = icon;
				end
			end
		end
	end
end



function SFBItemsDisplay_OnMouseDown(arg1)
	if (arg1 == "LeftButton") then
		SFBItemsFrame:StartMoving();
	end
end

function SFBItemsDisplay_OnMouseUp(arg1)
	if (arg1 == "LeftButton") then
		SFBItemsFrame:StopMovingOrSizing();
		SFBItemsDisplay_ChooseFrame();
	end
end

function SFBItemsDisplay_ContainerFrameItemButton_OnClick(button, ignoreShift)
	if ( CursorHasItem() ) then
		local bagnum = this:GetParent():GetID();
		local slotNum = this:GetID();
		--SFBItemsDisplay_Print("bagnum:"..bagnum)
		--SFBItemsDisplay_Print("slotnum:"..slotNum)
		local link = GetContainerItemLink(bagnum,slotNum)
		if ( link ) then
			--SFBItemsDisplay_Print("link:"..link)
			SFBITEMS_VAR_DraggedItem = GetItemInfo(link);
		
	
			local icon, _, _, _, _ = GetContainerItemInfo(this:GetParent():GetID(), this:GetID());
			SFBITEMS_VAR_DraggedTexture = icon;
			
			if ( IsControlKeyDown() and IsShiftKeyDown() ) then
				SFBItemsDisplay_Debug("Key is down");
				SFBItemsDisplay_Debug("SFBITEMS_VAR_DraggedItem: "..SFBITEMS_VAR_DraggedItem);
				SFBItemsDisplay_AddItem(SFBITEMS_VAR_DraggedItem,true,1);
				return;
			end
		end
		
		
	end
	
end

function SFBItemsDisplay_BankFrameItemButtonGeneric_OnClick(button, ignoreShift)
	
	-- SFBItemsDisplay_Original_BankFrameItemButtonGeneric_OnClick(button, ignoreShift);

	if ( not CursorHasItem() ) then
		local bagnum = BANK_CONTAINER;
		local slotNum = this:GetID();
		--SFBItemsDisplay_Print("bagnum:"..bagnum)
		--SFBItemsDisplay_Print("slotnum:"..slotNum)
		local link = GetContainerItemLink(bagnum,slotNum)
		if ( link ) then
			--SFBItemsDisplay_Print("link:"..link)
			SFBITEMS_VAR_DraggedItem = GetItemInfo(link);
		
	
			local icon, _, _, _, _ = GetContainerItemInfo(bagnum, slotNum);
			SFBITEMS_VAR_DraggedTexture = icon;
			
			if ( IsControlKeyDown() and IsShiftKeyDown() ) then

				SFBItemsDisplay_AddItem(SFBITEMS_VAR_DraggedItem,true,1);
				return;
			end
		end
		
		
	end
	
	
	
end




function SFBItemsDisplay_AddItem(item,showedit,cat,atLoc)

	if ( not cat ) then
		cat = 1;
	end
	if ( atLoc ) then
		if ( type(atLoc) == "number" ) then
			if ( atLoc == 0 ) then
				atLoc = true;
			end
		end
	end
	local newItem = {};		
	local found = false;
	if ( item ) then
		if ( type(item) == "table" ) then
		
		 	if ( not item.name ) then
		 		return;
		 	end
			local tCat,tInd = SFBItemsDisplay_GetItem(item.name);
			if ( not tCat ) then
				newItem = item;
				if ( atLoc ) then
					if ( type(atLoc) == "number" ) then
						tinsert(SFBItemsDisplay_CategoriesArray[cat].items,atLoc,item);
					else
						tinsert(SFBItemsDisplay_CategoriesArray[cat].items,item);
					end
				else
					tinsert(SFBItemsDisplay_CategoriesArray[cat].items,1,item);
				end
				SFBItemsDisplay_InitListItem(item);
				SFBItemsDisplay_CountBagItems();
			else
				if ( tCat ~= cat ) then
					newItem = item;
					table.remove(SFBItemsDisplay_CategoriesArray[tCat].items,tInd);
					if ( atLoc ) then
						if ( type(atLoc) == "number" ) then
							tinsert(SFBItemsDisplay_CategoriesArray[cat].items,atLoc,item);
						else
							tinsert(SFBItemsDisplay_CategoriesArray[cat].items,item);
						end
					else
						tinsert(SFBItemsDisplay_CategoriesArray[cat].items,1,item);
					end
					SFBItemsDisplay_InitListItem(item);
					SFBItemsDisplay_CountBagItems();
				else
					found = true;
				end
			end
	
		else
			if ( strlen(item) == 0 ) then
				return;
			end
			local tCat,tInd = SFBItemsDisplay_GetItem(item);
			if ( not tCat ) then
				newItem.name = item;
				newItem.alias = item;
				if ( SFBITEMS_VAR_HasDrag ) then
					newItem.icon = SFBITEMS_VAR_DraggedTexture;
				else
					newItem.icon = "";
				end
				if ( atLoc ) then
					if ( type(atLoc) == "number" ) then
						tinsert(SFBItemsDisplay_CategoriesArray[cat].items,atLoc,newItem);
					else
						tinsert(SFBItemsDisplay_CategoriesArray[cat].items,newItem);
					end
				else
					tinsert(SFBItemsDisplay_CategoriesArray[cat].items,1,newItem);
				end
				SFBItemsDisplay_InitListItem(newItem);
				SFBItemsDisplay_CountBagItems();
			else
				if ( tCat ~= cat ) then
					newItem = SFBItemsDisplay_CategoriesArray[tCat].items[tInd];
					table.remove(SFBItemsDisplay_CategoriesArray[tCat].items,tInd);
					
					newItem.name = item;
					newItem.alias = item;
					if ( atLoc ) then
						if ( type(atLoc) == "number" ) then
							tinsert(SFBItemsDisplay_CategoriesArray[cat].items,atLoc,newItem);
						else
							tinsert(SFBItemsDisplay_CategoriesArray[cat].items,newItem);
						end
					else
						tinsert(SFBItemsDisplay_CategoriesArray[cat].items,1,newItem);
					end
					SFBItemsDisplay_CountBagItems();
				else
					found = true;
				end
			end
		end
		
		if ( showedit and not found and SFBInventoryHawk_Player.showitemoptions == 1 ) then
			local nCat, nItem = SFBItemsDisplay_GetItem(newItem.name)
			SFBItemsDisplay_Debug("Open Added Item Options: "..newItem.name.." - "..nCat.." - "..nItem);
			SFBItemsDisplay_ItemOptions(nCat,nItem);
		elseif ( showedit and not found ) then
			SFBItemsDisplay_CountBagItems();
			SFBItemsDisplay_ChooseFrame();
		end
	end
	
	
end

function SFBItemsDisplay_IsNormalDisplay()

	local x,y = SFBInventoryHawkButton:GetCenter();
	if ( not y ) then
		return true;
	end
	

	
	if( y  < 150 or SFBInventoryHawk_Player.reverselist == 1 ) then
		return false;
	else
		return true;
	end	
	
	
end

function SFBItemsDisplay_OnShow()
	if ( SFBITEMS_VAR_Enabled ) then
		SFBItemsDisplay_ChooseAutoHide();
		SFBItemsDisplay_CreateCraftList();
	end
end

function SFBItemsDisplay_OnHide()
	SFBItemsDisplayListFrame:Hide();
end

function SFBItemsDisplay_ButtonTextOnClick(arg1)
	
	if ( IsControlKeyDown() and IsShiftKeyDown() ) then
		SFBItemsDisplay_MakeMenu();
		return;
	end
	local btCat, btItem;
	
	if (this.itemType == "reagent" ) then
		btCat , btItem = SFBItemsDisplay_GetItem(this.itemName);
	else
		btCat = SFBItemsDisplay_GetCategory(this.itemCat);
		if( arg1 == "RightButton" ) then
			btCat = SFBItemsDisplay_GetCategory(this.itemCat);
			btItem = 0;
			SFBItemsDisplay_ItemOptions(btCat,btItem);
			return;
			
		else
			if ( SFBItemsDisplay_CategoriesArray[btCat].open == 1 ) then
				SFBItemsDisplay_CategoriesArray[btCat].open = 0 
			else
				SFBItemsDisplay_CategoriesArray[btCat].open = 1 
			end
			SFBItemsDisplay_ChooseFrame();
			return;
		end
			
	end
	local rAction = 0;
	
	if ( btItem > 0 ) then
		tItem = SFBItemsDisplay_CategoriesArray[btCat].items[btItem];
		if ( arg1 == "RightButton" ) then
			if ( IsControlKeyDown() ) then
				rAction = tItem.rightcontrolclickaction;
			else
				rAction = tItem.rightclickaction;
			end
		end
		
		if ( rAction == 2 and strlen(tItem.rightclicktrade) > 0 and tItem.rightclickprofessionid > 1 ) then
			CloseTradeSkill();
			local prof = tItem.rightclickprofessionid;
			local spell = SFBItemsDisplay_ProfessionArray[prof][1];
			local spellID = SFBItemsDisplay_GetSpellID(spell);
			local tradeName
			if ( spellID ) then
				
				CastSpell(spellID,"general");
				for i = 0, GetNumTradeSkills(), 1 do
					tradeName,_, SFBITEMS_VAR_TradeSkillNum = GetTradeSkillInfo(i);
					if ( tradeName == tItem.rightclicktrade ) then
						SFBITEMS_VAR_TradeSkillId = i;
						break;
					end
				end
				if ( SFBITEMS_VAR_TradeSkillId > 0 ) then
					SelectTradeSkill(SFBITEMS_VAR_TradeSkillId);
					if ( SFBITEMS_VAR_TradeSkillNum  > 0 ) then
						
						if ( SFBITEMS_VAR_TradeSkillNum == 0 ) then
							DoTradeSkill(SFBITEMS_VAR_TradeSkillId);
						else
							SFBTradeSkillFrame_Show(btCat,btItem)
							
						end
					else
						SFBItemsDisplay_Error(SFBITEMS_TEXT_ERRORNOREAGENTS);
					end
					
				else
					SFBItemsDisplay_Error(SFBITEMS_TEXT_ERRORNOTRADESKILL);
				end
			else
				SFBItemsDisplay_Error("Cannot open "..SFBItemsDisplay_ProfessionArray[prof][1].." frame.");
			end
			CloseTradeSkill();
			return;
		elseif ( rAction == 1 ) then 
			
			local link = GetContainerItemLink(tItem.itembag, tItem.itemslot);
		  	local name = GetItemInfo(link);
		  	if ( name ) then
				UseContainerItem(tItem.itembag,tItem.itemslot);
			else
				SFBItemsDisplay_Error(SFBITEMS_TEXT_ERRORNOITEM);
			end
			return;
		end
		SFBItemsDisplay_ItemOptions(btCat,btItem);
	else
		SFBItemsDisplay_ItemOptions(btCat,btItem);
	end
end






function SFBItemsDisplay_ReceiveDrag(justAdd)
	local nbag = 0;
	
	
	if ( CursorHasItem() or justAdd ) then
		local btCat, btItem;
		if ( this.itemType == nil ) then
		 	btCat = 1;
		 	btItem = 0;
		elseif (this.itemType == "reagent" ) then
			btCat , btItem = SFBItemsDisplay_GetItem(this.itemName);
		else
			btCat = SFBItemsDisplay_GetCategory(this.itemCat);
			btItem = 0;
		end
		SFBITEMS_VAR_HasDrag = true;
		SFBItemsDisplay_AddItem(SFBITEMS_VAR_DraggedItem,true,btCat, btItem);
		ClearCursor();
	end
	SFBITEMS_VAR_HasDrag = false;
	SFBITEMS_VAR_IsBank = false;
	
end


function SFBItemsDisplay_MakeMenu()
	local cursorX, cursorY = GetCursorPosition();
	EasyMenu(MatTrack_Menu, getglobal("SFBItemsFrame_DropDown"), "UIParent", cursorX, cursorY, "MENU", 35);
	--ToggleDropDownMenu(1, nil, getglobal("SFBItemsFrame_DropDown"), "UIParent", cursorX, cursorY);
end

function SFBItemsDisplay_MakeTextButtonMenu()
	--local cursorX, cursorY = GetCursorPosition();
	--ToggleDropDownMenu(1, this:GetName(), getglobal("SFBItemsFrame_TextButtonDropDown"), "UIParent", cursorX, cursorY);
end

function SFBItemsFrame_DropDown_OnLoad()
	UIDropDownMenu_Initialize(this, MatTrack_DropDown_Initialize, "MENU", nil, MatTrack_Menu);
	--UIDropDownMenu_Initialize(this, SFBItemsDisplay_DropDown_Initialize, "MENU");
end

function SFBItemsFrame_TextButtonDropDown_OnLoad()
	--UIDropDownMenu_Initialize(this, SFBItemsFrame_TextButtonDropDown_Initialize, "MENU");
end

function MatTrack_DropDown_Initialize()
	MatTrack_AddMenu = {
}

	MatTrack_ItemMenu = {
					
}

	MatTrack_Menu = {
		{
		text = "- |cff0080ff"..SFBITEMS_TEXT_IHOPTIONS.."|r -";
		isTitle = 1;
		notClickable = 1;
		notCheckable = 1;
		},
		--{
		--text = SFBITEMS_TEXT_CATEGORIES;
		--notClickable = 1;
		--notCheckable = 1;
		--},

		--{
		--text = "";
		--notClickable = 1;
		--keepShownOnClick = 1;
		--notCheckable = 1;
		--},
		{
		text = SFBITEMS_TEXT_ADDOPTIONS;
		notClickable = 1;
		isTitle = 1;
		notCheckable = 1;
		},
		{
		text = SFBITEMS_TEXT_ADDITEM;
		func = SFBItemsDisplay_ManualAddItem;
		keepShownOnClick = 1;
		notCheckable = 1;
		},		
		{
		text = SFBITEMS_TEXT_ADDNEWCATEGORYBAR;
		func = SFBItemsDisplay_AddNewCategoryPopup;
		keepShownOnClick = 1;
		notCheckable = 1;
		},
		{	
		text = SFBITEMS_TEXT_TRACKACRAFTITEM;
		func = SFBItemsDisplay_AddTradeSkill;
		keepShownOnClick = 1;
		notCheckable = 1;
		},
		{
		text = "|cff0080ff==============|r";
		notClickable = 1;
		keepShownOnClick = 1;
		notCheckable = 1;
		},
		{
		text = SFBITEMS_TEXT_OPTIONS;
		func = SFBItemsDisplay_ShowOptions;
		notCheckable = 1;
		},
		{
		text = "";
		notClickable = 1;
		keepShownOnClick = 1;
		notCheckable = 1;
		},
		{
		text = SFBITEMS_TEXT_EXITMENU;
		func = SFBItemsDisplay_DropDown_ExitMenu;
		notCheckable = 1;
		}
	}
end

function SFBItemsFrame_GetItemToolTip()
	
	if (SFBInventoryHawk_Player.showtooltips == 1 ) then
		
		if ( SFBITEMS_VAR_MouseOverInfo.item == 0 ) then return; end
		
		local tList = 0;
		local tItem = nil;
		local screenH = GetScreenHeight();
		if ( not screenH or screenH == 0 ) then
			return;
		end
		
		local btCat, btItem;
		
		if (this.itemType == "reagent" ) then
			btCat , btItem = SFBItemsDisplay_GetItem(this.itemName);
			tItem = SFBItemsDisplay_CategoriesArray[btCat].items[btItem];
			if ( not tItem ) then
				return;
			end
		end
		
		local x,y = this:GetCenter();
		local xPos = 0;
		local yPos = 0;
		local anchor,relative;
		if ( not y or not x ) then
			return;
		end
		if( y  < screenH / 2 ) then
			anchor = "BOTTOM";
			relative = "TOP";
			yPos = yPos + 5;
		else
			anchor = "TOP";
			relative = "BOTTOM";
			yPos = yPos - 5;
		end	
	
		if( x < GetScreenWidth() / 2 ) then
			anchor = anchor.."LEFT";
			relative = relative.."RIGHT";
		else
			anchor = anchor.."RIGHT";
			relative = relative.."LEFT";
		end

		GameTooltip:SetOwner(this, "ANCHOR_NONE");
		
				
		if ( this.itemType == "reagent" ) then
					
			GameTooltip:AddLine(tItem.name,1,1,1);
				 		
			GameTooltip:AddDoubleLine(SFBITEMS_TEXT_ALIAS..":",tItem.alias,SFBITEMS_VAR_Colors.normal.r,SFBITEMS_VAR_Colors.normal.g,SFBITEMS_VAR_Colors.normal.b,1,1,1);
			GameTooltip:AddDoubleLine(SFBITEMS_TEXT_GOALAMOUNT..":",tItem.highlightnum,SFBITEMS_VAR_Colors.highlight.r,SFBITEMS_VAR_Colors.highlight.g,SFBITEMS_VAR_Colors.highlight.b,1,1,1);
			GameTooltip:AddDoubleLine(SFBITEMS_TEXT_CONVNUMBER..":",tItem.convamount,SFBITEMS_VAR_Colors.convertable.r,SFBITEMS_VAR_Colors.convertable.g,SFBITEMS_VAR_Colors.convertable.b,1,1,1);
			GameTooltip:AddDoubleLine(SFBITEMS_TEXT_WARNINGLVL..":",tItem.minalarm,SFBITEMS_VAR_Colors.minwarning.r,SFBITEMS_VAR_Colors.minwarning.g,SFBITEMS_VAR_Colors.minwarning.b,1,1,1);
			if ( tItem.rightclickprofessionid > 1 and strlen(tItem.rightclicktrade) > 0 ) then
				GameTooltip:AddDoubleLine(SFBITEMS_TEXT_TRADESKILLEXECUTE..":",tItem.rightclicktrade,SFBITEMS_VAR_Colors.trade.r,SFBITEMS_VAR_Colors.trade.g,SFBITEMS_VAR_Colors.trade.b,SFBITEMS_VAR_Colors.normal.r,SFBITEMS_VAR_Colors.normal.g,SFBITEMS_VAR_Colors.normal.b);
			end
			
			if ( SFBInventoryHawk_AltItems ) then
				if (SFBInventoryHawk_AltItems[tItem.name] ~= nil) then
					if (SFBInventoryHawk_AltItems[tItem.name].count > 0 and tItem.alt ~= 1) then
						GameTooltip:AddLine("Alt's Count"..":",SFBITEMS_VAR_Colors.alt.r,SFBITEMS_VAR_Colors.alt.g,SFBITEMS_VAR_Colors.alt.b,1,1,1);
						for index, value in pairs(SFBInventoryHawk_AltItems[tItem.name].alt) do
							GameTooltip:AddDoubleLine("     "..index..":",value.count,SFBITEMS_VAR_Colors.normal.r,SFBITEMS_VAR_Colors.normal.g,SFBITEMS_VAR_Colors.normal.b,1,1,1);
						end
					end
				end
			end		
			GameTooltip:SetPoint(anchor, this, relative, xPos,yPos );	
			GameTooltip:Show();
		else
			GameTooltip:AddLine(SFBITEMS_TEXT_CATEGORIES,1,1,1);
			GameTooltip:AddLine(SFBITEMS_TEXT_TOOLTIPCATEGORYLEFTCLICK,1,1,1);
			GameTooltip:AddLine(SFBITEMS_TEXT_TOOLTIPCATEGORYRIGHTCLICK,1,1,1);
			GameTooltip:SetPoint(anchor,this, relative, xPos,yPos );	
			GameTooltip:Show();
		end
		
	end
end

function SFBItemsDisplay_DropDown_Initialize(level)

	if (level == nil) then
		level = 1;
	end

	if (UIDROPDOWNMENU_MENU_VALUE == nil) then
		return;
	end
	
	if (level == 1) then

		local info = {};
		info.text = "- |cff0080ff"..SFBITEMS_TEXT_IHOPTIONS.."|r -";
		info.notClickable = 1;
		info.isTitle = 1;
		info.notCheckable = 1;
		UIDropDownMenu_AddButton(info);
		
		info = {};
		info.text = SFBITEMS_TEXT_ITEMTOPTIONS;
		info.hasArrow = 1;
		info.notCheckable = 1;
		UIDropDownMenu_AddButton(info);
		
		info = {};
		info.text = SFBITEMS_TEXT_ADDOPTIONS;
		info.hasArrow = 1;
		info.notCheckable = 1;
		UIDropDownMenu_AddButton(info);
		
		local info = {};
		info.text = SFBITEMS_TEXT_OPTIONS;
		info.func = SFBItemsDisplay_ShowOptions;
		info.notCheckable = 1;
		UIDropDownMenu_AddButton(info);
		
		local info = {};
		info.text = "";
		info.notClickable = 1;
		info.keepShownOnClick = 1;
		info.notCheckable = 1;
		UIDropDownMenu_AddButton(info);
		
		
		local info = {};
		info.text = SFBITEMS_TEXT_EXITMENU;
		info.func = SFBItemsDisplay_DropDown_ExitMenu;
		info.notCheckable = 1;
		UIDropDownMenu_AddButton(info);
	elseif (UIDROPDOWNMENU_MENU_VALUE == SFBITEMS_TEXT_ITEMTOPTIONS) then
			local info = {};
			info.text = SFBITEMS_TEXT_CATEGORIES;
			info.notClickable = 1;
			info.isTitle = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
			local totalItems = table.getn(SFBItemsDisplay_CategoriesArray);
			local thisMax = 25;
			local thisTotal = 0;
			if ( totalItems ) <= thisMax then 
				thisTotal = totalItems;
			else
				thisTotal = thisMax;
			end
			for ltcnt = 1, thisTotal, 1 do
				local info = {};
				info.text = SFBItemsDisplay_CategoriesArray[ltcnt].alias;
				info.value = ltcnt;
				info.keepShownOnClick = 1;
				info.hasArrow = 1;
				info.notCheckable = 1;
				UIDropDownMenu_AddButton(info,2);
			end
			
			local info = {};
			info.text = "";
			info.keepShownOnClick = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
			
			local info = {};
			info.text = SFBITEMS_TEXT_EXITMENU;
			info.func = SFBItemsDisplay_DropDown_ExitMenu;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
	elseif (UIDROPDOWNMENU_MENU_VALUE == SFBITEMS_TEXT_MOREITEMS) then
			local info = {};
			info.text = SFBITEMS_TEXT_DISPLAYITEMS;
			info.notClickable = 1;
			info.isTitle = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,3);
			local totalItems = table.getn(SFBItemsDisplay_ItemsArray);
			local thisMax = 26;
			for ltcnt = thisMax, totalItems, 1 do
				local info = {};
				info.text = SFBItemsDisplay_ItemsArray[ltcnt].alias;
				info.func = SFBItemsDisplay_ShowItemOptionDialog;
				info.value = ltcnt;
				info.keepShownOnClick = 1;
				info.notCheckable = 1;
				UIDropDownMenu_AddButton(info,3);
			end
			local info = {};
			info.text = SFBITEMS_TEXT_EXITMENU;
			info.func = SFBItemsDisplay_DropDown_ExitMenu;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,3);
	elseif (UIDROPDOWNMENU_MENU_VALUE == SFBITEMS_TEXT_ADDOPTIONS) then
			local info = {};
			info.text = SFBITEMS_TEXT_ADDOPTIONS;
			info.notClickable = 1;
			info.isTitle = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
			
			local info = {};
			info.text = SFBITEMS_TEXT_ADDITEM;
			info.func = SFBItemsDisplay_ManualAddItem;
			info.keepShownOnClick = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
			
			local info = {};
			info.text = SFBITEMS_TEXT_ADDNEWCATEGORYBAR;
			info.func = SFBItemsDisplay_AddNewCategoryPopup;
			info.keepShownOnClick = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
			
			local info = {};
			info.text = SFBITEMS_TEXT_TRACKACRAFTITEM;
			info.func = SFBItemsDisplay_AddTradeSkill;
			info.keepShownOnClick = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
			
			local info = {};
			info.text = "";
			info.keepShownOnClick = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
			
			local info = {};
			info.text = SFBITEMS_TEXT_TOADDITEMS;
			info.notClickable = 1;
			info.keepShownOnClick = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
			
			local info = {};
			info.text = SFBITEMS_TEXT_TOPTOOLTUP1;
			info.notClickable = 1;
			info.keepShownOnClick = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
			
			local info = {};
			info.text = SFBITEMS_TEXT_TOPTOOLTUP2;
			info.notClickable = 1;
			info.keepShownOnClick = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
			
			local info = {};
			info.text = SFBITEMS_TEXT_TOPTOOLTUP3;
			info.notClickable = 1;
			info.keepShownOnClick = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
			
			local info = {};
			info.text = SFBITEMS_TEXT_TOPTOOLTUP4;
			info.notClickable = 1;
			info.keepShownOnClick = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
			
			local info = {};
			info.text = "";
			info.keepShownOnClick = 1;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
			
			local info = {};
			info.text = SFBITEMS_TEXT_EXITMENU;
			info.func = SFBItemsDisplay_DropDown_ExitMenu;
			info.notCheckable = 1;
			UIDropDownMenu_AddButton(info,2);
	else 
		local totalItems = table.getn(SFBItemsDisplay_CategoriesArray);
		local thisMax = 25;
		local thisTotal = 0;
		if ( totalItems ) <= thisMax then 
			thisTotal = totalItems;
		else
			thisTotal = thisMax;
		end
		for ltcnt = 1, thisTotal, 1 do
			if (UIDROPDOWNMENU_MENU_VALUE == ltcnt) then
				local info = {};
				info.text = SFBITEMS_TEXT_DISPLAYITEMS;
				info.notClickable = 1;
				info.isTitle = 1;
				info.notCheckable = 1;
				UIDropDownMenu_AddButton(info,3);
				local totalIItems = table.getn(SFBItemsDisplay_CategoriesArray[ltcnt].items);
				local thisIMax = 25;
				local thisITotal = 0;
				if ( totalItems ) <= thisMax then 
					thisITotal = totalIItems;
				else
					thisITotal = thisIMax;
				end
				if ( ltcnt > 1 ) then
					local info = {};
					info.text = SFBITEMS_TEXT_EDITTHISCATEGORY;
					info.func = SFBItemsDisplay_ShowCatOptionDialog;
					info.value = ltcnt
					info.keepShownOnClick = 1;
					info.notCheckable = 1;
					UIDropDownMenu_AddButton(info,3);
					
					local info = {};
					info.text = "";
					info.keepShownOnClick = 1;
					info.notCheckable = 1;
					UIDropDownMenu_AddButton(info,3);
				end
				
				
			
				for lticnt = 1, thisITotal, 1 do
					local info = {};
					info.text = SFBItemsDisplay_CategoriesArray[ltcnt].items[lticnt].alias;
					info.func = SFBItemsDisplay_ShowItemOptionDialog;
					info.keepShownOnClick = 1;
					info.value = SFBItemsDisplay_CategoriesArray[ltcnt].items[lticnt].name;
					info.notCheckable = 1;
					UIDropDownMenu_AddButton(info,3);
				end
				
				local info = {};
				info.text = "";
				info.keepShownOnClick = 1;
				info.notCheckable = 1;
				UIDropDownMenu_AddButton(info,3);
				
				local info = {};
				info.text = SFBITEMS_TEXT_EXITMENU;
				info.func = SFBItemsDisplay_DropDown_ExitMenu;
				info.notCheckable = 1;
				UIDropDownMenu_AddButton(info,3);
				break;
			end
		end			
	
	end
end

function SFBItemsDisplay_OnEnter()
	SFBITEMS_VAR_MouseEntered = true;
	if ( SFBInventoryHawk_Player.permhidetitlebutton == 0 ) then
		if ( SFBInventoryHawk_Player.autohidetitlebutton == 1 ) then
			SFBInventoryHawkButton:SetAlpha(1.0);
			SFBItemsBackdropFrame:SetAlpha(SFBInventoryHawk_Player.titlebuttonalpha);
		end
	end
	
	SFBItemsDisplay_ChooseFrame();
	
end 

function SFBItemsButton_OnEnter()
	
	if ( this.itemType == "reagent" ) then
		local tText = getglobal(this:GetName().."Text");
		SFBITEMS_VAR_Colors.last.r,SFBITEMS_VAR_Colors.last.g,SFBITEMS_VAR_Colors.last.b = tText:GetTextColor();
		tText:SetTextColor(SFBITEMS_VAR_Colors.over.r,SFBITEMS_VAR_Colors.over.g,SFBITEMS_VAR_Colors.over.b);
	end
	
	SFBITEMS_VAR_MouseEntered = true;
	if ( SFBInventoryHawk_Player.permhidetitlebutton == 0 ) then
		if ( SFBInventoryHawk_Player.autohidetitlebutton == 1 ) then
			SFBInventoryHawkButton:SetAlpha(1.0);
			SFBItemsBackdropFrame:SetAlpha(SFBInventoryHawk_Player.titlebuttonalpha);
		end
	end
	
end

function SFBItemsDisplay_OnLeave()
	SFBITEMS_VAR_MouseEntered = false;
	
	if ( SFBInventoryHawk_Player.autohidetitlebutton == 1 ) then
		SFBInventoryHawkButton:SetAlpha(0.0);
		SFBItemsBackdropFrame:SetAlpha(0.0);
	end
	
	
	
	SFBItemsDisplay_ChooseFrame();
end

function SFBItemsButton_OnLeave()
	SFBITEMS_VAR_MouseEntered = false;
	if ( SFBInventoryHawk_Player.autohidetitlebutton == 1 ) then
		SFBInventoryHawkButton:SetAlpha(0.0);
		SFBItemsBackdropFrame:SetAlpha(0.0);
	end
	if ( this.itemType == "reagent" ) then
		local tText = getglobal(this:GetName().."Text");
		tText:SetTextColor(SFBITEMS_VAR_Colors.last.r,SFBITEMS_VAR_Colors.last.g,SFBITEMS_VAR_Colors.last.b);
	end
	
end

function SFBItemsDisplay_ArbAutoHideTitleButton()
	if ( SFBInventoryHawk_Player.autohidetitlebutton == 1 or SFBInventoryHawk_Player.permhidetitlebutton == 1 ) then
		if ( SFBInventoryHawk_Player.permhidetitlebutton == 1 ) then
			SFBInventoryHawkButton:SetFrameStrata("BACKGROUND");
			SFBItemsBackdropFrame:SetFrameStrata("BACKGROUND");
		end
		SFBInventoryHawkButton:SetAlpha(0.0);
		SFBItemsBackdropFrame:SetAlpha(0.0);
	else
		SFBInventoryHawkButton:SetAlpha(1.0);
		SFBItemsBackdropFrame:SetAlpha(SFBInventoryHawk_Player.titlebuttonalpha);
		SFBInventoryHawkButton:SetFrameStrata("MEDIUM");
		SFBItemsBackdropFrame:SetFrameStrata("MEDIUM");
	end
end

function SFBItemsDisplay_ArbAutoHideList()
	SFBItemsDisplay_ChooseFrame();
end


function SFBItemsDisplay_ShowOptions()
	InventoryHawkOptions_DialogFrame:Show();
end

function SFBItemsDisplay_ChooseAutoHide()
	if ( SFBITEMS_VAR_Enabled == false ) then
		return;
	end
	
	
	SFBItemsDisplay_ChooseFrame();
			
	SFBItemsDisplay_CheckTitleShow();
	
	SFBItemsDisplay_ArbAutoHideTitleButton();
	
	
end 

function SFBItemsDisplay_ChooseFrame(forceShow)
	SFBItemsDisplay_DisplayList(forceShow);
	SFBItemsDisplay_SetupBags();
	
end

function SFBItemsDisplay_DropDown_ExitMenu()
	CloseDropDownMenus();
end

function SFBItemsDisplay_AddNewCategoryPopup()
	StaticPopup_Show("SFBItemsDisplay_AddCategory");
	SFBItemsDisplay_DropDown_ExitMenu();
end

function SFBItemsDisplay_CheckTitleShow()
	
	for value in pairs(SFBITEMS_VAR_TitleButtons) do
				
		if (SFBInventoryHawk_Player.titlebuttondisplay == value) then
			getglobal(SFBITEMS_VAR_TitleButtons[value]):Show();
			if (value == "reagent") then
				SFBItemsDisplay_SetReagentTitle();
			end
			
		else
			getglobal(SFBITEMS_VAR_TitleButtons[value]):Hide();
		end
	end
	
	SFBItemsDisplay_ScaleTitle();
	SFBItemsDisplay_ChooseFrame();
end

function IWMoneyDisplay_UpdateMoneyDisplay() 
	IWMyGoldButton:Show();
	IWMySilverButton:Show();
	IWMyCopperButton:Show();
	local currentMoney = 0;
	currentMoney = GetMoney();
	
	local gold = math.floor(currentMoney / COPPER_PER_GOLD);
	currentMoney = currentMoney - gold * COPPER_PER_GOLD;
	local silver = math.floor(currentMoney / COPPER_PER_SILVER);
	currentMoney = currentMoney - silver * COPPER_PER_SILVER;
	local copper = currentMoney;
	IWMyGoldButtonText:SetText(gold);
	IWMySilverButtonText:SetText(silver);
	IWMyCopperButtonText:SetText(copper);
	SFBItemsDisplay_ScaleTitle();
end


function SFBItemsDisplay_ShowItemOptionDialog()
	SFBItemsDisplay_DropDown_ExitMenu();
	local tcat, titem = SFBItemsDisplay_GetItem(this.value);
	SFBItemsDisplay_ItemOptions(tcat,titem); 
	
end

function SFBItemsDisplay_ShowCatOptionDialog()
	SFBItemsDisplay_DropDown_ExitMenu();
	SFBItemsDisplay_ItemOptions(this.value); 
end

function SFBItemsDisplay_ResetItem(cat, item)
	local tItem = nil;
	if ( type(item) == "number" ) then
		tItem = SFBItemsDisplay_CategoriesArray[cat].items[item];
	else
		tItem = item;
	end
	if ( not tItem ) then
		return;
	end
	tItem.show = 1;
	tItem.convamount = 0;
	tItem.alarm = 0;
	tItem.minalarm = 0;
	tItem.highlightnum = 0;
	tItem.forceshow = 0;
	tItem.goalincludebank = 0;
	tItem.convincludebank = 0;
	tItem.warnincludebank = 0;
	
	SFBItemsDisplay_ChooseFrame();

end 





function SFBItemsDisplay_ToggleEvenEmptyItems()
	SFBItemsDisplay_TogglePlayerArrayVar("hideempty",SFBItemsDisplay_ChooseFrame);
end



function SFBItemsDisplay_ManualAddItem()
	SFBITEMS_VAR_HasDrag = false;
	StaticPopup_Show("SFBItemsDisplay_AddItem");
   	SFBItemsDisplay_DropDown_ExitMenu();
end

function SFBItemsDisplay_RemoveItem(cat,itemnum)
	
	StaticPopupDialogs["SFBItemsDisplay_RemoveItem"] = {
		text = SFBITEMS_TEXT_REMOVE.." "..SFBItemsDisplay_CategoriesArray[cat].items[itemnum].name,
		button1 = TEXT(ACCEPT),
		button2 = TEXT(CANCEL),
		whileDead = 1,
		OnAccept = function()
			SFBItemsDisplay_DoRemoveItem(cat,itemnum);
		end,
		timeout = 0
	};
	StaticPopup_Show("SFBItemsDisplay_RemoveItem");
   	SFBItemsDisplay_DropDown_ExitMenu();
end

function SFBItemsDisplay_RemoveCat(cat)
	
	StaticPopupDialogs["SFBItemsDisplay_RemoveCat"] = {
		text = SFBITEMS_TEXT_REMOVE.." "..SFBItemsDisplay_CategoriesArray[cat].name,
		button1 = TEXT(ACCEPT),
		button2 = TEXT(CANCEL),
		whileDead = 1,
		OnAccept = function()
			SFBItemsDisplay_DoRemoveCat(cat);
		end,
		timeout = 0
	};
	StaticPopup_Show("SFBItemsDisplay_RemoveCat");
   	SFBItemsDisplay_DropDown_ExitMenu();
end



function SFBItemsDisplay_DoRemoveItem(cat,itemnum)
	if ( not itemnum or not cat) then
		return;
	end
	
	table.remove(SFBItemsDisplay_CategoriesArray[cat].items,itemnum);
	SFBItemsDisplay_CountBagItems();
	SFBItemsDisplay_ChooseFrame();
end

function SFBItemsDisplay_DoRemoveCat(cat)

	if ( not cat ) then
		return;
	end
	
	table.remove(SFBItemsDisplay_CategoriesArray,cat);
	SFBItemsDisplay_CountBagItems();
	SFBItemsDisplay_ChooseFrame();
end


function SFBItemsDisplay_ScaleTitle()
	if ( SFBITEMS_VAR_Enabled == false ) then
		return;
	end
	local tWidth = 0;
	local MainFrame = getglobal(SFBITEMS_VAR_MainFrame);
	if ( SFBInventoryHawk_Player.titlebuttondisplay == "money" ) then
		
		
		IWMyCopperButtonText:SetTextHeight(SFBInventoryHawk_Player.titlefontsize);
		IWMyCopperButtonText:SetHeight(SFBInventoryHawk_Player.titlefontsize);
		
		IWMySilverButtonText:SetTextHeight(SFBInventoryHawk_Player.titlefontsize);
		IWMySilverButton:SetHeight(SFBInventoryHawk_Player.titlefontsize);
		
		IWMyGoldButtonText:SetTextHeight(SFBInventoryHawk_Player.titlefontsize);
		IWMyGoldButton:SetHeight(SFBInventoryHawk_Player.titlefontsize);
		
		local wCopper = SFBInventoryHawk_Player.titlefontsize + IWMyCopperButtonText:GetStringWidth();
		local wSilver = SFBInventoryHawk_Player.titlefontsize + IWMySilverButtonText:GetStringWidth();
		local wGold = SFBInventoryHawk_Player.titlefontsize + IWMyGoldButtonText:GetStringWidth();
		IWMyCopperButton:SetWidth(wCopper);
		IWMySilverButton:SetWidth(wSilver);
		IWMyGoldButton:SetWidth(wGold);
		tWidth = wCopper + wSilver + wSilver + 35;
		
		if ( tWidth < SFBITEMS_CONS_TEXTWIDTH ) then
			tWidth = SFBITEMS_CONS_TEXTWIDTH;
		end
		
		IWMyGoldButtonTexture:SetHeight(SFBInventoryHawk_Player.titlefontsize);
		IWMyGoldButtonTexture:SetWidth(SFBInventoryHawk_Player.titlefontsize);
		IWMySilverButtonTexture:SetHeight(SFBInventoryHawk_Player.titlefontsize);
		IWMySilverButtonTexture:SetWidth(SFBInventoryHawk_Player.titlefontsize);
		IWMyCopperButtonTexture:SetHeight(SFBInventoryHawk_Player.titlefontsize);
		IWMyCopperButtonTexture:SetWidth(SFBInventoryHawk_Player.titlefontsize);
		
		MainFrame:SetWidth(tWidth);
		SFBInventoryHawkButton:SetWidth(tWidth);
		SFBInventoryHawkButtonText:SetWidth(tWidth);
		SFBItemsBackdropFrame:SetWidth(tWidth);
		IWMoneyDisplayButton:SetWidth(tWidth);
		IWMoneyDisplayButton:SetScale(2); 
		IWMoneyDisplayButton:SetScale(SFBITEMS_CONS_SETSCALE); 
		
	elseif ( SFBInventoryHawk_Player.titlebuttondisplay ==  "reagent" ) then
			
		SFBItemsReagentDisplayText:SetTextHeight(SFBInventoryHawk_Player.titlefontsize);
		local tWidth = SFBItemsReagentDisplayText:GetStringWidth() + SFBInventoryHawk_Player.titlefontsize + 25;
		if ( tWidth < SFBITEMS_CONS_TEXTWIDTH ) then
			tWidth = SFBITEMS_CONS_TEXTWIDTH;
		end
		SFBItemsReagentDisplayTexture:SetWidth(SFBInventoryHawk_Player.titlefontsize);
		SFBItemsReagentDisplayTexture:SetHeight(SFBInventoryHawk_Player.titlefontsize);
		
		MainFrame:SetWidth(tWidth);
		SFBInventoryHawkButton:SetWidth(tWidth);
		SFBInventoryHawkButtonText:SetWidth(tWidth);
		SFBItemsBackdropFrame:SetWidth(tWidth);
		
		SFBItemsReagentDisplay:SetWidth(tWidth);
		SFBItemsReagentDisplay:SetScale(2);
		SFBItemsReagentDisplay:SetScale(SFBITEMS_CONS_SETSCALE);
	
	else
		SFBInventoryHawkButtonText:SetTextHeight(SFBInventoryHawk_Player.titlefontsize);
		local tWidth = SFBInventoryHawkButtonText:GetStringWidth() + 20;
		if ( tWidth < SFBITEMS_CONS_TEXTWIDTH ) then
			tWidth = SFBITEMS_CONS_TEXTWIDTH;
		end
		
		MainFrame:SetWidth(tWidth);
		SFBInventoryHawkButton:SetWidth(tWidth);
		SFBInventoryHawkButtonText:SetWidth(tWidth);
		SFBItemsBackdropFrame:SetWidth(tWidth);
	
		IWTitleDisplayButton:SetWidth(tWidth);
				
		IWTitleDisplayButton:SetScale(2); 
		IWTitleDisplayButton:SetScale(SFBITEMS_CONS_SETSCALE); 
		
	end
	
	
		
	local tHeight = SFBInventoryHawk_Player.titlefontsize + ( SFBInventoryHawk_Player.titlefontsize / 2 );
	if ( tHeight < SFBITEMS_CONS_MINTITLEHEIGHT ) then
		tHeight = SFBITEMS_CONS_MINTITLEHEIGHT;
	end
	SFBInventoryHawkButton:SetHeight(tHeight);
	IWTitleDisplayButton:SetHeight(tHeight);
	SFBItemsBackdropFrame:SetHeight(tHeight);
end

function SFBItemsDisplay_SetTitle(title) 
	
	SFBInventoryHawk_Player.title = title;
	SFBInventoryHawkButtonText:SetText(SFBInventoryHawk_Player.title);
	local tWidth = SFBInventoryHawkButtonText:GetStringWidth() + 10;
	
	SFBItemsDisplay_ScaleTitle();
	
end



function SFBItemsDisplay_ClickedDisable()
   StaticPopup_Show("SFBItemsDisplay_Disable");
   SFBItemsDisplay_DropDown_ExitMenu();
end

function SFBItemsDisplay_ClickClearList()
   StaticPopup_Show("SFBItemsDisplay_ClearList");
   SFBItemsDisplay_DropDown_ExitMenu();
   
end

function SFBItemsDisplay_ClearList()
	for ltcnt = table.getn(SFBItemsDisplay_CategoriesArray), 2, -1 do
		table.remove(SFBItemsDisplay_CategoriesArray,ltcnt);
	end
	
	for ltscnt = table.getn(SFBItemsDisplay_CategoriesArray[1].items), 1, -1 do
		table.remove(SFBItemsDisplay_CategoriesArray[1].items,ltscnt);
	end
	
	-- SFBItemsDisplay_CountBagItems();
	SFBItemsDisplay_ChooseFrame();
end

function SFBItemsDisplay_AddTradeSkill()
	local trade = GetTradeSkillSelectionIndex();

	if (trade == 0) then
		SFBItemsDisplay_Error(SFBITEMS_TEXT_SELECTATRADE);
		return;
	end
	
	
	local skillName = GetTradeSkillInfo(trade);
	skillName = "Craft: "..skillName; 
	SFBItemsDisplay_AddCategoryNEW(skillName);
	local tCcat = SFBItemsDisplay_GetCategory(skillName);
	local numReagents = GetTradeSkillNumReagents(trade);
	for rcnt = 1 ,numReagents, 1 do
		local name, texture, count, _ = GetTradeSkillReagentInfo(trade, rcnt);
		local newItem = {};
		newItem.name = name;
		newItem.alias = name;
		newItem.convamount = count;
		newItem.hidewhenempty = 0;
		newItem.highlightnum = count;
		newItem.icon = texture;	
		SFBItemsDisplay_AddItem(newItem,false,tCcat)		
	end
	SFBItemsDisplay_CountBagItems();
	SFBItemsDisplay_ChooseFrame();

end

function SFBItemsDisplay_SetReagentTitle()
	if ( SFBItemsDisplay_CategoriesArray[1].items[1] ) then
		SFBItemsReagentDisplayTexture:SetTexture(SFBItemsDisplay_CategoriesArray[1].items[1].icon);

		SFBItemsReagentDisplayText:SetText(SFBItemsDisplay_CategoriesArray[1].items[1].alias..": "..SFBItemsDisplay_CategoriesArray[1].items[1].count);
	else
		SFBItemsDisplay_Error(SFBITEMS_TEXT_ERROR);
		
	end
end





function SFBItemsDisplay_GetTrades() 
	local tradeSkillsNum;
	local name, type;
	for i=1,GetNumTradeSkills() do
		name, type, _, _ = GetTradeSkillInfo(i);
	   	if (type ~= "header") then
	      		DEFAULT_CHAT_FRAME:AddMessage("Found: "..name);

	   	end

	end
end



function SFBItemsDisplay_Print(msg) 
	if ( ( msg ) and ( strlen(msg) > 0 ) ) then
		if ( DEFAULT_CHAT_FRAME ) then
			DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
		end
	end
end

function SFBItemsDisplay_UIPrint(msg) 
	if ( ( msg ) and ( strlen(msg) > 0 ) ) then
		UIErrorsFrame:AddMessage(msg, 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
	end
end

function SFBItemsDisplay_Debug(msg)
	if ( SFBITEMS_CONS_DEBUG ) then
		if ( ( msg ) and ( strlen(msg) > 0 ) ) then
			if ( DEFAULT_CHAT_FRAME ) then
				DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, .5);
			end
		end
	end
end

function SFBItemsDisplay_Error(msg)
	if ( ( msg ) and ( strlen(msg) > 0 ) ) then
		UIErrorsFrame:AddMessage(msg, 1.0, 0.0, 0.0, 1.0, UIERRORS_HOLD_TIME);
	end
end

function MatTrack_ICSlider_OnValueChanged()
	InventoryHawkOptions_TitleOptionsBorderFrame_ICSliderText:SetText("In-Combat Alpha: "..this:GetValue());
	SFBInventoryHawk_Player.MatTrack_ICAlpha = this:GetValue() * 0.01;
	if (ICBOOL == true) then
		SFBItemsFrame:SetAlpha(SFBInventoryHawk_Player.MatTrack_ICAlpha);
		SFBItemsDisplayListFrame:SetAlpha(SFBInventoryHawk_Player.MatTrack_ICAlpha);
	end
end

function MatTrack_OCSlider_OnValueChanged()
	InventoryHawkOptions_TitleOptionsBorderFrame_OCSliderText:SetText("Out-Of-Combat Alpha: "..this:GetValue());
	SFBInventoryHawk_Player.MatTrack_OCAlpha = this:GetValue() * 0.01;
	if (ICBOOL == false) then
		SFBItemsFrame:SetAlpha(SFBInventoryHawk_Player.MatTrack_OCAlpha);
		SFBItemsDisplayListFrame:SetAlpha(SFBInventoryHawk_Player.MatTrack_OCAlpha);
	end
end
