local ThisItemName;
function SFBItemsDisplay_GetNumber(anum)
	if ( anum ) then
		return anum;
	else
		return 0;
	end
end

function SFBItemsDisplay_ItemOptions(cat, item)
	SFBItemsDisplay_Debug("SFBItemsDisplay_ItemOptions");
	if ( not cat or cat == 0 ) then
		SFBItemsDisplay_Debug("SFBItemsDisplay_ItemOptions no Category");
		return;
	else
		SFBITEMS_VAR_SelectedCat = cat;
		SFBITEMS_VAR_SelectedItem = item;
	end
	
	SFBItemsDisplay_Debug("SFBITEMS_VAR_SelectedCat: "..SFBITEMS_VAR_SelectedCat);
	
	local tItem = nil;
	SFBItemsOptionsTopFrame:Hide();
	SFBItemsOptionsLowerFrame:Hide();
	SFBItemsOptionsCategoryTopFrame:Hide();
	SFBItemsDisplayItemOptionsFrame:Show();
	SFBItemsDisplayItemOptionsFrameRemoveItemButton:Hide();
	SFBItemsDisplayItemOptionsFrameRemoveCatButton:Hide();
	SFBItemsDisplayItemOptionsFrameResetItemButton:Hide();
	
		
	if ( not SFBITEMS_VAR_SelectedItem or SFBITEMS_VAR_SelectedItem == 0 ) then
		tItem = SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat];
		ThisItemName = tItem.name;
		SFBItemsDisplayItemOptionsFrameTitle:SetText(tItem.name);
		SFBItemsDisplayItemOptionsFrameHeaderIconFrame:Hide();
		SFBItemsOptionsCategoryTopFrame:Show();
		SFBItemsDisplayItemOptionsFrameRemoveCatButton:Show();
		-- SFBItemsOptionsLowerFrame:Show();
		SFBItemsOptionsCategoryTopFrameHideEmptyCheck:SetChecked(tItem.hideemptycategory)
		SFBItemsOptionsCategoryTopFrameHideEmptyCheckText:SetText(SFBITEMS_TEXT_HIDEEMPTYCATEGORY);
		SFBItemsOptionsCategoryTopFrameAliasEdit:SetText(tItem.alias);
		SFBItemsOptionsCategoryTopFrameTimesEdit:SetText(tItem.times);
		SFBItemsOptionsCategoryTopFrameAliasLabel:SetText(SFBITEMS_TEXT_ALIAS);
		SFBItemsOptionsCategoryTopFrameTimesLabel:SetText("Multiplier:");
		-- Slider
		SFBItemsDisplaySlotOptionTitle:SetText(SFBITEMS_TEXT_SORTITEM);
		SFBItemsDisplaySlotOptionSliderText:SetText(SFBITEMS_VAR_SelectedCat);
		SFBItemsDisplaySlotOptionSliderHigh:SetText(table.getn(SFBItemsDisplay_CategoriesArray));
		SFBItemsDisplaySlotOptionSliderLow:SetText("2");
		SFBItemsDisplaySlotOptionSlider:SetMinMaxValues(2, table.getn(SFBItemsDisplay_CategoriesArray));
		SFBItemsDisplaySlotOptionSlider:SetValueStep(1);
		SFBItemsDisplaySlotOptionSlider:SetValue(SFBITEMS_VAR_SelectedCat);
		
		SFBItemsOptionsLowerFrameProfessionIcon:SetTexture(tItem.rightclickprofessionicon);
		SFBItemsOptionsLowerFrameSkillIcon:SetTexture(tItem.rightclicktradeicon );
	else
		tItem = SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem];
		ThisItemName = tItem.name;
		SFBItemsDisplayItemOptionsFrameTitle:SetText(tItem.name);
		SFBItemsDisplayItemOptionsFrameHeaderIconFrame:SetTexture(tItem.icon);
		SFBItemsDisplayItemOptionsFrameHeaderIconFrame:Show();
		SFBItemsDisplayItemOptionsFrameRemoveItemButton:Show();
		SFBItemsDisplayItemOptionsFrameResetItemButton:Show();
		SFBItemsOptionsTopFrame:Show();
		SFBItemsOptionsLowerFrame:Show();
		SFBItemsOptionsTopFrameAliasEdit:SetText(tItem.alias);
		SFBItemsOptionsTopFrameAliasLabel:SetText(SFBITEMS_TEXT_ALIAS);
		SFBItemsOptionsTopFrameGoalEdit:SetText(SFBItemsDisplay_GetNumber(tItem.highlightnum));
		SFBItemsOptionsTopFrameGoalLabel:SetText("|cff3fbf3f"..SFBITEMS_TEXT_GOALAMOUNT.."|r");
		SFBItemsOptionsTopFrameConvertEdit:SetText(SFBItemsDisplay_GetNumber(tItem.convamount));
		SFBItemsOptionsTopFrameConvertLabel:SetText("|cff00b2ff"..SFBITEMS_TEXT_CONVNUMBER.."|r");
		SFBItemsOptionsTopFrameWarningEdit:SetText(SFBItemsDisplay_GetNumber(tItem.minalarm));
		SFBItemsOptionsTopFrameWarningLabel:SetText("|cffff4c19"..SFBITEMS_TEXT_WARNINGLVL.."|r");
		
		-- Added by Enitjus --
		if ( not SFBITEMS_VAR_ShowAltCounts) then SFBItemsOptionsTopFrameAltCheck:Hide(); end
		SFBItemsOptionsTopFrameAltCheck:SetChecked(tItem.alt);
		SFBItemsOptionsTopFrameAltCheckText:SetText(SFBITEMS_TEXT_ALTCHECK);
		-- End Add --
		
		SFBItemsOptionsTopFrameWarningCheck:SetChecked(tItem.alarm);
		SFBItemsOptionsTopFrameWarningCheckText:SetText(SFBITEMS_TEXT_TURNONWARNING);
		SFBItemsOptionsTopFrameGoalBankCheck:SetChecked(tItem.goalincludebank);
		SFBItemsOptionsTopFrameGoalBankCheckText:SetText(SFBITEMS_TEXT_INCBANKINGOAL);
		SFBItemsOptionsTopFrameGoalHideCheckText:SetText(SFBITEMS_TEXT_HIDEONGOAL);
		SFBItemsOptionsTopFrameGoalHideCheck:SetChecked(tItem.hideongoalreached);
		SFBItemsOptionsTopFrameResetGoalCheck:SetChecked(tItem.resetgoal);
		SFBItemsOptionsTopFrameResetGoalCheckText:SetText(SFBITEMS_TEXT_OPTIONRESETGOAL);
		SFBItemsOptionsTopFrameWarnBankCheckText:SetText(SFBITEMS_TEXT_INCBANKINWARNING);
		SFBItemsOptionsTopFrameWarnBankCheck:SetChecked(tItem.warnincludebank);
		SFBItemsOptionsTopFrameHideCheckText:SetText(SFBITEMS_TEXT_HIDE);
		SFBItemsOptionsTopFrameHideCheck:SetChecked(tItem.hide);
		SFBItemsOptionsTopFrameHideEmptyCheckText:SetText(SFBITEMS_TEXT_HIDEWHENEMPTY);
		SFBItemsOptionsTopFrameHideEmptyCheck:SetChecked(tItem.hidewhenempty);
		SFBItemsOptionsTopFrameBankShowCheckText:SetText(SFBITEMS_TEXT_SHOWIFBANK);
		SFBItemsOptionsTopFrameBankShowCheck:SetChecked(tItem.showifbank);
		SFBItemsOptionsTopFrameAutoHideCheckText:SetText(SFBITEMS_TEXT_AUTOHIDEITEM);
		SFBItemsOptionsTopFrameAutoHideCheck:SetChecked(tItem.autohide);
		SFBItemsOptionsTopFrameHideTilGoalCheckText:SetText(SFBITEMS_TEXT_HIDEUNTILGOAL);
		SFBItemsOptionsTopFrameHideTilGoalCheck:SetChecked(tItem.hidetilgoal);
		SFBItemsOptionsTopFrameHideTilConversionCheckText:SetText(SFBITEMS_TEXT_HIDEUNTILCONVERSION);
		SFBItemsOptionsTopFrameHideTilConversionCheck:SetChecked(tItem.hidetilconv);
		
		SFBItemsOptionsLowerFrameProfessionIcon:SetTexture(tItem.rightclickprofessionicon);
		SFBItemsOptionsLowerFrameSkillIcon:SetTexture(tItem.rightclicktradeicon );
		
		SFBItemsOptionsLowerFrameActionLabel:SetText(tItem.rightclicktrade );
		-- Slider
		SFBItemsDisplaySlotOptionTitle:SetText(SFBITEMS_TEXT_SORTITEM);
		SFBItemsDisplaySlotOptionSliderText:SetText(SFBITEMS_VAR_SelectedItem);
		SFBItemsDisplaySlotOptionSliderHigh:SetText(table.getn(SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items));
		SFBItemsDisplaySlotOptionSliderLow:SetText("1");
		SFBItemsDisplaySlotOptionSlider:SetMinMaxValues(1, table.getn(SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items));
		SFBItemsDisplaySlotOptionSlider:SetValueStep(1);
		SFBItemsDisplaySlotOptionSlider:SetValue(SFBITEMS_VAR_SelectedItem);
	
	end
	
				
	tItem = nil;
	
	SFBItemsDisplay_DropDown_ExitMenu();
end

function SFBItemsOptionsDisplay_OnMouseDown(arg1)
	if (arg1 == "LeftButton") then
		this:StartMoving();
	end
end

function SFBItemsOptionsDisplay_OnMouseUp(arg1)
	if (arg1 == "LeftButton") then
		this:StopMovingOrSizing();
	end
end



function SFBItemsDisplaySlotOptionSlider_OnValueChanged()
	if ( not SFBITEMS_VAR_SelectedItem or SFBITEMS_VAR_SelectedItem == 0 ) then
		local tItem = SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat];
		local rItem = tremove(SFBItemsDisplay_CategoriesArray,SFBITEMS_VAR_SelectedCat);
		tinsert(SFBItemsDisplay_CategoriesArray,this:GetValue(),rItem);
		SFBITEMS_VAR_SelectedCat = this:GetValue();
		SFBItemsDisplay_ChooseFrame(true);
		getglobal(this:GetName().."Text"):SetText(SFBITEMS_VAR_SelectedCat);
	else
		local tItem = SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem];
		local rItem = tremove(SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items,SFBITEMS_VAR_SelectedItem);
		tinsert(SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items,this:GetValue(),rItem);
		SFBITEMS_VAR_SelectedItem = this:GetValue();
		SFBItemsDisplay_ChooseFrame(true);
		getglobal(this:GetName().."Text"):SetText(SFBITEMS_VAR_SelectedItem);
	end
end

function SFBItemsOptionsTopFrameGoalEdit_OnValueChanged()
	local value = tonumber(SFBItemsOptionsTopFrameGoalEdit:GetText());
	if (type(value) == "number") then
		SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].highlightnum = value;
		SFBItemsDisplay_ChooseFrame();
	end
end

function SFBItemsOptionsTopFrameConvertEdit_OnValueChanged()
	local value = tonumber(SFBItemsOptionsTopFrameConvertEdit:GetText());
	if (type(value) == "number") then
		SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].convamount = value;
		SFBItemsDisplay_ChooseFrame();
	end
end

function SFBItemsOptionsTopFrameWarningEdit_OnValueChanged()
	local value = tonumber(SFBItemsOptionsTopFrameWarningEdit:GetText());
	if (type(value) == "number") then
		SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].minalarm = value;
		SFBItemsDisplay_ChooseFrame();
	end
end

function SFBItemsOptionsTopFrameAliasEdit_OnValueChanged()
	local value = SFBItemsOptionsTopFrameAliasEdit:GetText();
	if (strlen(value) > 0 ) then
		SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].alias = value;
		SFBItemsDisplay_ChooseFrame();
	end
end

function SFBItemsOptionsCategoryTopFrameAliasEdit_OnValueChanged()
	local value = SFBItemsOptionsCategoryTopFrameAliasEdit:GetText();
	if (strlen(value) > 0 ) then
		SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].alias = value;
		SFBItemsDisplay_ChooseFrame();
	end
end

function SFBItemsOptionsCategoryTopFrameTimesEdit_OnValueChanged()
	local value = SFBItemsOptionsCategoryTopFrameTimesEdit:GetText();
	if (strlen(value) > 0 ) then
		SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].times = value;
		SFBItemsDisplay_ChooseFrame();
	end
end

function  SFBItemsOptionsDisplay_SetCheck(itemVar, checked)
	if (checked) then
		SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem][itemVar] = 1;
	else
		SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem][itemVar] = 0;
	end
	SFBItemsDisplay_ChooseFrame();
end

function  SFBItemsOptionsDisplay_CatSetCheck(itemVar, checked)
	if (checked) then
		SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat][itemVar] = 1;
	else
		SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat][itemVar] = 0;
	end
	SFBItemsDisplay_ChooseFrame();
end

function SFBItemsOptionsCategoryTopFrameHideEmptyCheck_OnClick()
	SFBItemsOptionsDisplay_CatSetCheck("hideemptycategory",this:GetChecked());
end

function SFBItemsOptionsTopFrameWarningCheck_OnClick()

	SFBItemsOptionsDisplay_SetCheck("alarm",this:GetChecked());
end

function SFBItemsOptionsTopFrameHideCheck_OnClick()
	SFBItemsOptionsDisplay_SetCheck("hide",this:GetChecked());
end

function SFBItemsOptionsTopFrameResetGoalCheck_OnClick()
	SFBItemsOptionsDisplay_SetCheck("resetgoal",this:GetChecked());
end

-- Added by Enitjus --
function SFBItemsOptionsTopFrameAltCheck_OnClick()
    	SFBItemsOptionsDisplay_SetCheck("alt",this:GetChecked());
end
-- End Add --
	
function SFBItemsOptionsTopFrameAutoHideCheck_OnClick()
	SFBItemsOptionsDisplay_SetCheck("autohide",this:GetChecked());
end

function SFBItemsOptionsTopFrameHideEmptyCheck_OnClick()
	SFBItemsOptionsDisplay_SetCheck("hidewhenempty",this:GetChecked());
end

function SFBItemsOptionsTopFrameBankShowCheck_OnClick()
	SFBItemsOptionsDisplay_SetCheck("showifbank",this:GetChecked());
end

function SFBItemsOptionsTopFrameGoalBankCheck_OnClick()
	SFBItemsOptionsDisplay_SetCheck("goalincludebank",this:GetChecked());
end

function SFBItemsOptionsTopFrameGoalHideCheck_OnClick()
	SFBItemsOptionsDisplay_SetCheck("hideongoalreached",this:GetChecked());
end

function SFBItemsOptionsTopFrameWarnBankCheck_OnClick()
	SFBItemsOptionsDisplay_SetCheck("warnincludebank",this:GetChecked());
end

function SFBItemsOptionsTopFrameHideTilGoalCheck_OnClick()
	SFBItemsOptionsDisplay_SetCheck("hidetilgoal",this:GetChecked());
end

function SFBItemsOptionsTopFrameHideTilConversionCheck_OnClick()
	SFBItemsOptionsDisplay_SetCheck("hidetilconv",this:GetChecked());
end



function SFBItemsOptionsTopFrameSaveAsDefault_OnClick()
	local tItem = SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem];
	
	SFBInventoryHawk_Player.defaultitemsettings.alarm =tItem.alarm;
	SFBInventoryHawk_Player.defaultitemsettings.goalincludebank =tItem.goalincludebank;
	SFBInventoryHawk_Player.defaultitemsettings.hideongoalreached =tItem.hideongoalreached;
	SFBInventoryHawk_Player.defaultitemsettings.warnincludebank =tItem.warnincludebank;
	SFBInventoryHawk_Player.defaultitemsettings.hide =tItem.hide;
	SFBInventoryHawk_Player.defaultitemsettings.hidewhenempty =tItem.hidewhenempty;
	SFBInventoryHawk_Player.defaultitemsettings.showifbank =tItem.showifbank;
	SFBInventoryHawk_Player.defaultitemsettings.autohide =tItem.autohide;
	SFBInventoryHawk_Player.defaultitemsettings.alt =tItem.alt;
	SFBInventoryHawk_Player.defaultitemsettings.resetgoal =tItem.resetgoal;
		
		
end

function SFBItemsOptionsLowerFrameAddActionButton_OnClick()

	local trade = GetTradeSkillSelectionIndex();

	if (trade == 0) then
		UIErrorsFrame:AddMessage(SFBITEMS_TEXT_SELECTATRADE, 1.0, 0.0, 0.0, 1.0, UIERRORS_HOLD_TIME);
		return;
	end
	
	SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclicktrade = GetTradeSkillInfo(trade);
	SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclicktradeicon = GetTradeSkillIcon(trade);
	SFBItemsOptionsLowerFrameSkillIcon:SetTexture(SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclicktradeicon );
	SFBItemsOptionsLowerFrameActionLabel:SetText(SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclicktrade);
	CloseTradeSkill();
	
end

function SFBItemsOptionsLowerFrameProfessionButton_OnClick()
	local prof = UIDropDownMenu_GetSelectedValue(SFBItemsOptionsLowerFrameProfessionsDropDown);
	local spell = SFBItemsDisplay_ProfessionArray[prof][1];
	local spellID = SFBItemsDisplay_GetSpellID(spell);

	if ( spellID ) then
		CastSpell(spellID,"general");
	end
end

function SFBItemsOptionsLowerFrameProfessionsDropDown_OnShow()
	UIDropDownMenu_Initialize(this, SFBItemsOptionsLowerFrameProfessionsDropDown_Initialize);
end



function SFBItemsOptionsLowerFrameProfessionsDropDown_Initialize()
	SFBItemsDisplay_CreateCraftList();
	local prof = SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclickprofessionid;
	if ( prof == 0 ) then
		prof = 1;
	end
	for i=1, getn(SFBItemsDisplay_ProfessionArray), 1  do
		info = {};
		info.text = SFBItemsDisplay_ProfessionArray[i][1];
		info.value = i;
		info.func = SFBItemsOptionsLowerFrameProfessionsDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
	
	UIDropDownMenu_SetSelectedValue(SFBItemsOptionsLowerFrameProfessionsDropDown, prof);
	
	
	
	
end

function SFBItemsOptionsLowerFrameProfessionsDropDown_OnClick()
	UIDropDownMenu_SetSelectedValue(SFBItemsOptionsLowerFrameProfessionsDropDown, this.value);
	SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclickprofessionid =  this.value;
	if ( SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclickprofessionid > 1 ) then
		local prof = SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclickprofessionid;
		local spell = SFBItemsDisplay_ProfessionArray[prof][1];
		local spellID = 0;
		spellID = SFBItemsDisplay_GetSpellID(spell);
		-- SFBItemsDisplay_Print(spellID);
		if ( spellID and spellID > 0 ) then
			SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclickprofessionicon = GetSpellTexture(spellID,"general");
			SFBItemsOptionsLowerFrameProfessionIcon:SetTexture(SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclickprofessionicon);
		end
	else
	
		SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclickprofessionicon = "";
		SFBItemsOptionsLowerFrameProfessionIcon:SetTexture("");
		SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclicktrade = "";
		SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclicktradeicon = "";
		SFBItemsOptionsLowerFrameSkillIcon:SetTexture(SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclicktradeicon );
		SFBItemsOptionsLowerFrameActionLabel:SetText(SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclicktrade);
	end
	
end

function SFBItemsOptionsCategoryTopFrameCategorySelection_Initialize()
	for index, value in pairs(SFBItemsDisplay_CategoriesArray) do
		local info = {};
		info.text = SFBItemsDisplay_CategoriesArray[index].alias;
		info.value = index;
		info.func = SFBItemsOptionsCategoryTopFrameCategorySelection_OnClick;
		UIDropDownMenu_AddButton(info);
	end
	UIDropDownMenu_SetSelectedValue(SFBItemsOptionsCategoryTopFrameCategorySelection, SFBITEMS_VAR_SelectedCat);
	
end

function SFBItemsOptionsCategoryTopFrameCategorySelection_OnClick()
	UIDropDownMenu_SetSelectedValue(SFBItemsOptionsCategoryTopFrameCategorySelection, this.value);
	SFBITEMS_VAR_SelectedCat = this.value
	SFBItemsDisplay_AddItem(ThisItemName,false,SFBITEMS_VAR_SelectedCat);
	local cat, item = SFBItemsDisplay_GetItem(ThisItemName);
	SFBITEMS_VAR_SelectedCat = cat;
	SFBITEMS_VAR_SelectedItem = item;
	SFBItemsDisplaySlotOptionSliderText:SetText(SFBITEMS_VAR_SelectedItem);
	SFBItemsDisplaySlotOptionSliderHigh:SetText(table.getn(SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items));
	SFBItemsDisplaySlotOptionSliderLow:SetText("1");
	SFBItemsDisplaySlotOptionSlider:SetMinMaxValues(1, table.getn(SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items));
	SFBItemsDisplaySlotOptionSlider:SetValueStep(1);
	SFBItemsDisplaySlotOptionSlider:SetValue(SFBITEMS_VAR_SelectedItem);
end

function SFBItemsDisplayItemOptionsFrameRemoveItemButton_OnClick()
	SFBItemsDisplay_RemoveItem(SFBITEMS_VAR_SelectedCat,SFBITEMS_VAR_SelectedItem);
	
	SFBItemsDisplayItemOptionsFrame:Hide();
end

function SFBItemsDisplayItemOptionsFrameRemoveCatButton_OnClick()
	SFBItemsDisplay_RemoveCat(SFBITEMS_VAR_SelectedCat);
	
	SFBItemsDisplayItemOptionsFrame:Hide();
end
function SFBItemsDisplayItemOptionsFrameResetItemButton_OnClick()
	SFBItemsDisplay_ResetItem(SFBITEMS_VAR_SelectedCat,SFBITEMS_VAR_SelectedItem);
	SFBItemsDisplayItemOptionsFrame:Hide();
	SFBItemsDisplay_ItemOptions(SFBITEMS_VAR_SelectedCat,SFBITEMS_VAR_SelectedItem);
end

function SFBItemsOptionsLowerFrameRightButtonDropDown_OnShow()
	UIDropDownMenu_Initialize(this, SFBItemsOptionsLowerFrameRightButtonDropDown_Initialize);
end

function SFBItemsOptionsLowerFrameRightButtonDropDown_Initialize()
	
	local val = SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclickaction;
	
	for value in pairs(SFBITEMS_VAR_RightClickAction) do
		local info = {};
		info.text = SFBITEMS_VAR_RightClickAction[value];
		info.value = value;
		info.checked = nil;
		info.func = SFBItemsOptionsLowerFrameRightButton_OnClick;
		UIDropDownMenu_AddButton(info);
		if (val == value) then
			UIDropDownMenu_SetText(SFBItemsOptionsLowerFrameRightButtonDropDown, info.text);
			
		end
		
	end
	
	UIDropDownMenu_SetSelectedValue(SFBItemsOptionsLowerFrameRightButtonDropDown, val);
end

function SFBItemsOptionsLowerFrameRightButton_OnClick()
	UIDropDownMenu_SetSelectedValue(SFBItemsOptionsLowerFrameRightButtonDropDown, this.value);
	SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightclickaction = UIDropDownMenu_GetSelectedValue(SFBItemsOptionsLowerFrameRightButtonDropDown);
	
end

function SFBItemsOptionsLowerFrameControlRightButtonDropDown_OnShow()
	UIDropDownMenu_Initialize(this, SFBItemsOptionsLowerFrameControlRightButtonDropDown_Initialize);
end

function SFBItemsOptionsLowerFrameControlRightButtonDropDown_Initialize()
	
	local val = SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightcontrolclickaction;
	
	for value in pairs(SFBITEMS_VAR_RightClickAction) do
		local info = {};
		info.text = SFBITEMS_VAR_RightClickAction[value];
		info.value = value;
		info.checked = nil;
		info.func = SFBItemsOptionsLowerFrameControlRightButtonDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
		if (val == value) then
			UIDropDownMenu_SetText(SFBItemsOptionsLowerFrameControlRightButtonDropDown, info.text);
		end
		
	end
	
	UIDropDownMenu_SetSelectedValue(SFBItemsOptionsLowerFrameControlRightButtonDropDown, val);
	
end

function SFBItemsOptionsLowerFrameControlRightButtonDropDown_OnClick()
	UIDropDownMenu_SetSelectedValue(SFBItemsOptionsLowerFrameControlRightButtonDropDown, this.value);
	SFBItemsDisplay_CategoriesArray[SFBITEMS_VAR_SelectedCat].items[SFBITEMS_VAR_SelectedItem].rightcontrolclickaction = UIDropDownMenu_GetSelectedValue(SFBItemsOptionsLowerFrameControlRightButtonDropDown);
end